# generated by gen_param_defs.py for 95ac42a5329ec391f348c4dd375663667282ecd6999e40ba22dd1f864c82b803
import struct
from . import enum36 as enum
class _ParamDefBase:
   def serialize(self):
       tag = struct.pack("I", type(self).TAG)
       pdata = [getattr(self, i) for i in self.__slots__]
       for idx, v in enumerate(pdata):
           if isinstance(v, _EnumBase):
               pdata[idx] = _enum_member2num[id(v)]
       return tag + self._packer.pack(*pdata)


class _EnumBase(enum.Enum):
   @classmethod
   def __normalize(cls, val):
       if isinstance(val, str):
           if not hasattr(cls, "__member_upper_dict__"):
               cls.__member_upper_dict__ = {k.upper(): v
                   for k, v in cls.__members__.items()}
           val = cls.__member_upper_dict__.get(val.upper(),val)
       return val
   @classmethod
   def convert(cls, val):
       val = cls.__normalize(val)
       if isinstance(val, cls):
           return val
       return cls(val)
   @classmethod
   def _missing_(cls, value):
       vnorm = cls.__normalize(value)
       if vnorm is not value:
           return cls(vnorm)
       return super()._missing_(value)


def _as_dtype_num(dtype):
    import megengine.core._imperative_rt.utils as m
    return m._get_dtype_num(dtype)


def _as_serialized_dtype(dtype):
    import megengine.core._imperative_rt.utils as m
    return m._get_serialized_dtype(dtype)


class Empty(_ParamDefBase):
    TAG = 3334509756
    __slots__ = []
    _packer = struct.Struct("x")
    def __init__(self):
        """
        """

class Axis(_ParamDefBase):
    TAG = 850869422
    __slots__ = ["axis"]
    _packer = struct.Struct("i0i")
    def __init__(self, axis=0):
        """
        :type axis: :class:`.int`
        """
        self.axis = int(axis)

class ConvolutionV0(_ParamDefBase):
    TAG = 2883667579
    class Mode(_EnumBase):
        CROSS_CORRELATION = "CROSS_CORRELATION"
        CONVOLUTION = "CONVOLUTION"
    
    class DataType(_EnumBase):
        FLOAT = "FLOAT"
        """
        input/output both float32/float16
        """
        INT8x8x16 = "INT8x8x16"
        INT8x8x32 = "INT8x8x32"
        FLOAT_IO16xC32 = "FLOAT_IO16xC32"
        """
        input/output both float16, the internal compute is float32
        """
        QUINT8x8x32 = "QUINT8x8x32"
        """
        input QuantizedAsymm8, output QuantizedS32
        """
        INT8x8xX = "INT8x8xX"
        """
        input int8, output specified by tensor DType
        """
        QUINT4x4x32 = "QUINT4x4x32"
        """
        input QuantizedAsymm4, output QuantizedS32
        """
    
    class Sparse(_EnumBase):
        DENSE = "DENSE"
        """
        dense convolution: filter shape should be [oc, ic, spatial...] if format
        is NCHW, [oc, spatial..., ic] if format is NHWC
        """
        GROUP = "GROUP"
        """
        group convolution: filter shape should be [group, oc_per_group,
        ic_per_group, spatial...] if format is NCHW, [group, oc_per_group,
        spatial..., ic_per_group] if format is NHWC
        """
    
    class Format(_EnumBase):
        """
        convolution data/filter/output format; see :class:`RelayoutFormat` for
        more details
        """
        NCHW = "NCHW"
        NHWC = "NHWC"
        NHWCD4 = "NHWCD4"
        NCHW4 = "NCHW4"
        NCHW8 = "NCHW8"
        NCHW32 = "NCHW32"
        NCHW88 = "NCHW88"
        NCHW44 = "NCHW44"
        NCHW44_DOT = "NCHW44_DOT"
        NCHW_WINOGRAD = "NCHW_WINOGRAD"
        """
        NCHW layout with weights tranformed by winograd
        """
        NCHW88_WINOGRAD = "NCHW88_WINOGRAD"
        """
        NCHW88 layout with weights tranformed by winograd
        """
        NCHW44_WINOGRAD = "NCHW44_WINOGRAD"
        """
        NCHW44 layout with weights tranformed by winograd
        """
        CHWN4 = "CHWN4"
        """
        CHWN4 is currently only used on Nvidia platform for fast implementation
        of convolution using CUDA/SASS. The channels are splitted to groups of 4
        channels.
        """
    
    __slots__ = ["mode", "pad_h", "pad_w", "stride_h", "stride_w", "dilate_h", "dilate_w", "data_type", "sparse", "format"]
    _packer = struct.Struct("IIIIIIIIII0I")
    def __init__(self, mode='CROSS_CORRELATION', pad_h=0, pad_w=0, stride_h=1, stride_w=1, dilate_h=1, dilate_w=1, data_type='FLOAT', sparse='DENSE', format='NCHW'):
        """
        :type mode: :class:`.ConvolutionV0.Mode`
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the first dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the second dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the first dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the second dimension
        :type dilate_h: :class:`.int`
        :param dilate_h: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type dilate_w: :class:`.int`
        :param dilate_w: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type data_type: :class:`.ConvolutionV0.DataType`
        :type sparse: :class:`.ConvolutionV0.Sparse`
        :type format: :class:`.ConvolutionV0.Format`
        """
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)
        self.data_type = ConvolutionV0.DataType.convert(data_type)
        self.sparse = ConvolutionV0.Sparse.convert(sparse)
        self.format = ConvolutionV0.Format.convert(format)

class Convolution(_ParamDefBase):
    TAG = 3401828963
    Mode = ConvolutionV0.Mode
    Sparse = ConvolutionV0.Sparse
    Format = ConvolutionV0.Format
    class ComputeMode(_EnumBase):
        """
        Specifies special computation modes, e.g. different combinations of
        intermediate result data types.
        """
        DEFAULT = "DEFAULT"
        """
        No special requirements on the precision of intermediate results.
        """
        FLOAT32 = "FLOAT32"
        """
        Use Float32 accumulator and intermediate result. Only supported when
        input and output is Float16.
        """
    
    __slots__ = ["mode", "pad_h", "pad_w", "stride_h", "stride_w", "dilate_h", "dilate_w", "sparse", "format", "compute_mode"]
    _packer = struct.Struct("IIIIIIIIII0I")
    def __init__(self, mode='CROSS_CORRELATION', pad_h=0, pad_w=0, stride_h=1, stride_w=1, dilate_h=1, dilate_w=1, sparse='DENSE', format='NCHW', compute_mode='DEFAULT'):
        """
        :type mode: :class:`.ConvolutionV0.Mode`
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the first dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the second dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the first dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the second dimension
        :type dilate_h: :class:`.int`
        :param dilate_h: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type dilate_w: :class:`.int`
        :param dilate_w: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type sparse: :class:`.ConvolutionV0.Sparse`
        :type format: :class:`.ConvolutionV0.Format`
        :type compute_mode: :class:`.Convolution.ComputeMode`
        """
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)
        self.sparse = ConvolutionV0.Sparse.convert(sparse)
        self.format = ConvolutionV0.Format.convert(format)
        self.compute_mode = Convolution.ComputeMode.convert(compute_mode)

class MaskPropagate(_ParamDefBase):
    TAG = 3985030427
    __slots__ = ["pad_h", "pad_w", "stride_h", "stride_w", "kernel_h", "kernel_w", "dilate_h", "dilate_w"]
    _packer = struct.Struct("IIIIIIII0I")
    def __init__(self, pad_h=0, pad_w=0, stride_h=1, stride_w=1, kernel_h=1, kernel_w=1, dilate_h=1, dilate_w=1):
        """
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the first dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the second dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the first dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the second dimension
        :type kernel_h: :class:`.int`
        :param kernel_h: kernel height
        :type kernel_w: :class:`.int`
        :param kernel_w: kernel width
        :type dilate_h: :class:`.int`
        :param dilate_h: dilate height
        :type dilate_w: :class:`.int`
        :param dilate_w: dilate width
        """
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.kernel_h = int(kernel_h)
        self.kernel_w = int(kernel_w)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)

class ConvPooling(_ParamDefBase):
    TAG = 937489154
    class Method(_EnumBase):
        WITH_TEXTURE_OBJ = "WITH_TEXTURE_OBJ"
        WITH_SHARED_MEM = "WITH_SHARED_MEM"
    
    ConvMode = ConvolutionV0.Mode
    class PoolMode(_EnumBase):
        AVERAGE = "AVERAGE"
        MAX = "MAX"
    
    class NonlineMode(_EnumBase):
        IDENTITY = "IDENTITY"
        RELU = "RELU"
        SIGMOID = "SIGMOID"
    
    __slots__ = ["method", "convMode", "poolMode", "nonlineMode", "pool_shape_h", "pool_shape_w", "pool_stride_h", "pool_stride_w", "pool_pad_h", "pool_pad_w", "conv_stride_h", "conv_stride_w", "conv_pad_h", "conv_pad_w"]
    _packer = struct.Struct("IIIIIIIIIIIIII0I")
    def __init__(self, method='WITH_TEXTURE_OBJ', convMode='CROSS_CORRELATION', poolMode='AVERAGE', nonlineMode='IDENTITY', pool_shape_h=1, pool_shape_w=1, pool_stride_h=1, pool_stride_w=1, pool_pad_h=0, pool_pad_w=0, conv_stride_h=1, conv_stride_w=1, conv_pad_h=0, conv_pad_w=0):
        """
        :type method: :class:`.ConvPooling.Method`
        :type convMode: :class:`.ConvolutionV0.Mode`
        :type poolMode: :class:`.ConvPooling.PoolMode`
        :type nonlineMode: :class:`.ConvPooling.NonlineMode`
        :type pool_shape_h: :class:`.int`
        :type pool_shape_w: :class:`.int`
        :type pool_stride_h: :class:`.int`
        :type pool_stride_w: :class:`.int`
        :type pool_pad_h: :class:`.int`
        :type pool_pad_w: :class:`.int`
        :type conv_stride_h: :class:`.int`
        :type conv_stride_w: :class:`.int`
        :type conv_pad_h: :class:`.int`
        :type conv_pad_w: :class:`.int`
        """
        self.method = ConvPooling.Method.convert(method)
        self.convMode = ConvolutionV0.Mode.convert(convMode)
        self.poolMode = ConvPooling.PoolMode.convert(poolMode)
        self.nonlineMode = ConvPooling.NonlineMode.convert(nonlineMode)
        self.pool_shape_h = int(pool_shape_h)
        self.pool_shape_w = int(pool_shape_w)
        self.pool_stride_h = int(pool_stride_h)
        self.pool_stride_w = int(pool_stride_w)
        self.pool_pad_h = int(pool_pad_h)
        self.pool_pad_w = int(pool_pad_w)
        self.conv_stride_h = int(conv_stride_h)
        self.conv_stride_w = int(conv_stride_w)
        self.conv_pad_h = int(conv_pad_h)
        self.conv_pad_w = int(conv_pad_w)

class ConvBiasV0(_ParamDefBase):
    """
    legacy conv_bias
    """
    TAG = 1139437340
    class NonlineMode(_EnumBase):
        IDENTITY = "IDENTITY"
        RELU = "RELU"
        SIGMOID = "SIGMOID"
        H_SWISH = "H_SWISH"
    
    Mode = ConvolutionV0.Mode
    __slots__ = ["nonlineMode", "mode", "pad_h", "pad_w", "stride_h", "stride_w"]
    _packer = struct.Struct("IIIIII0I")
    def __init__(self, nonlineMode='IDENTITY', mode='CROSS_CORRELATION', pad_h=0, pad_w=0, stride_h=1, stride_w=1):
        """
        :type nonlineMode: :class:`.ConvBiasV0.NonlineMode`
        :type mode: :class:`.ConvolutionV0.Mode`
        :type pad_h: :class:`.int`
        :type pad_w: :class:`.int`
        :type stride_h: :class:`.int`
        :type stride_w: :class:`.int`
        """
        self.nonlineMode = ConvBiasV0.NonlineMode.convert(nonlineMode)
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)

class ConvBiasV1(_ParamDefBase):
    """
    active(conv(x, w) + bias)
    """
    TAG = 3097296471
    NonlineMode = ConvBiasV0.NonlineMode
    Mode = ConvolutionV0.Mode
    DataType = ConvolutionV0.DataType
    Sparse = ConvolutionV0.Sparse
    Format = ConvolutionV0.Format
    __slots__ = ["nonlineMode", "mode", "data_type", "sparse", "format", "pad_h", "pad_w", "stride_h", "stride_w", "dilate_h", "dilate_w"]
    _packer = struct.Struct("IIIIIIIIIII0I")
    def __init__(self, nonlineMode='IDENTITY', mode='CROSS_CORRELATION', data_type='FLOAT', sparse='DENSE', format='NCHW', pad_h=0, pad_w=0, stride_h=1, stride_w=1, dilate_h=1, dilate_w=1):
        """
        :type nonlineMode: :class:`.ConvBiasV0.NonlineMode`
        :type mode: :class:`.ConvolutionV0.Mode`
        :type data_type: :class:`.ConvolutionV0.DataType`
        :type sparse: :class:`.ConvolutionV0.Sparse`
        :type format: :class:`.ConvolutionV0.Format`
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the first dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the second dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the first dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the second dimension
        :type dilate_h: :class:`.int`
        :param dilate_h: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type dilate_w: :class:`.int`
        :param dilate_w: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        """
        self.nonlineMode = ConvBiasV0.NonlineMode.convert(nonlineMode)
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.data_type = ConvolutionV0.DataType.convert(data_type)
        self.sparse = ConvolutionV0.Sparse.convert(sparse)
        self.format = ConvolutionV0.Format.convert(format)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)

class ConvBiasV2(_ParamDefBase):
    """
    active(conv(x, w) + bias)
    """
    TAG = 3865950583
    NonlineMode = ConvBiasV0.NonlineMode
    Mode = ConvolutionV0.Mode
    Sparse = ConvolutionV0.Sparse
    Format = ConvolutionV0.Format
    ComputeMode = Convolution.ComputeMode
    __slots__ = ["nonlineMode", "mode", "sparse", "format", "pad_h", "pad_w", "stride_h", "stride_w", "dilate_h", "dilate_w", "compute_mode"]
    _packer = struct.Struct("IIIIIIIIIII0I")
    def __init__(self, nonlineMode='IDENTITY', mode='CROSS_CORRELATION', sparse='DENSE', format='NCHW', pad_h=0, pad_w=0, stride_h=1, stride_w=1, dilate_h=1, dilate_w=1, compute_mode='DEFAULT'):
        """
        :type nonlineMode: :class:`.ConvBiasV0.NonlineMode`
        :type mode: :class:`.ConvolutionV0.Mode`
        :type sparse: :class:`.ConvolutionV0.Sparse`
        :type format: :class:`.ConvolutionV0.Format`
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the first dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the second dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the first dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the second dimension
        :type dilate_h: :class:`.int`
        :param dilate_h: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type dilate_w: :class:`.int`
        :param dilate_w: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type compute_mode: :class:`.Convolution.ComputeMode`
        """
        self.nonlineMode = ConvBiasV0.NonlineMode.convert(nonlineMode)
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.sparse = ConvolutionV0.Sparse.convert(sparse)
        self.format = ConvolutionV0.Format.convert(format)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)
        self.compute_mode = Convolution.ComputeMode.convert(compute_mode)

class ConvBias(_ParamDefBase):
    """
    active(conv(x, w) + bias)
    """
    TAG = 631167930
    NonlineMode = ConvBiasV0.NonlineMode
    Mode = ConvolutionV0.Mode
    Sparse = ConvolutionV0.Sparse
    Format = ConvolutionV0.Format
    ComputeMode = Convolution.ComputeMode
    __slots__ = ["nonlineMode", "mode", "sparse", "format", "pad_h", "pad_w", "stride_h", "stride_w", "dilate_h", "dilate_w", "output_block_size", "compute_mode"]
    _packer = struct.Struct("IIIIIIIIIIII0I")
    def __init__(self, nonlineMode='IDENTITY', mode='CROSS_CORRELATION', sparse='DENSE', format='NCHW', pad_h=0, pad_w=0, stride_h=1, stride_w=1, dilate_h=1, dilate_w=1, output_block_size=0, compute_mode='DEFAULT'):
        """
        :type nonlineMode: :class:`.ConvBiasV0.NonlineMode`
        :type mode: :class:`.ConvolutionV0.Mode`
        :type sparse: :class:`.ConvolutionV0.Sparse`
        :type format: :class:`.ConvolutionV0.Format`
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the first dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the second dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the first dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the second dimension
        :type dilate_h: :class:`.int`
        :param dilate_h: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type dilate_w: :class:`.int`
        :param dilate_w: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type output_block_size: :class:`.int`
        :param output_block_size: detail meaning \see winograd in conv bias
        :type compute_mode: :class:`.Convolution.ComputeMode`
        """
        self.nonlineMode = ConvBiasV0.NonlineMode.convert(nonlineMode)
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.sparse = ConvolutionV0.Sparse.convert(sparse)
        self.format = ConvolutionV0.Format.convert(format)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)
        self.output_block_size = int(output_block_size)
        self.compute_mode = Convolution.ComputeMode.convert(compute_mode)

class SeparableConv(_ParamDefBase):
    TAG = 2073960474
    Mode = ConvolutionV0.Mode
    class BorderMode(_EnumBase):
        BORDER_REPLICATE = "BORDER_REPLICATE"
        BORDER_REFLECT = "BORDER_REFLECT"
        BORDER_REFLECT_101 = "BORDER_REFLECT_101"
        BORDER_WRAP = "BORDER_WRAP"
        BORDER_CONSTANT = "BORDER_CONSTANT"
        BORDER_TRANSPARENT = "BORDER_TRANSPARENT"
        BORDER_ISOLATED = "BORDER_ISOLATED"
    
    __slots__ = ["mode", "borderMode", "is_symm_kernel", "pad_h", "pad_w", "stride_h", "stride_w", "ksize_h", "ksize_w", "anchor_h", "anchor_w"]
    _packer = struct.Struct("II?IIIIIIII0I")
    def __init__(self, mode='CROSS_CORRELATION', borderMode='BORDER_REPLICATE', is_symm_kernel=True, pad_h=0, pad_w=0, stride_h=1, stride_w=1, ksize_h=3, ksize_w=3, anchor_h=1, anchor_w=1):
        """
        :type mode: :class:`.ConvolutionV0.Mode`
        :type borderMode: :class:`.SeparableConv.BorderMode`
        :type is_symm_kernel: :class:`.bool`
        :type pad_h: :class:`.int`
        :type pad_w: :class:`.int`
        :type stride_h: :class:`.int`
        :type stride_w: :class:`.int`
        :type ksize_h: :class:`.int`
        :type ksize_w: :class:`.int`
        :type anchor_h: :class:`.int`
        :type anchor_w: :class:`.int`
        """
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.borderMode = SeparableConv.BorderMode.convert(borderMode)
        self.is_symm_kernel = bool(is_symm_kernel)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.ksize_h = int(ksize_h)
        self.ksize_w = int(ksize_w)
        self.anchor_h = int(anchor_h)
        self.anchor_w = int(anchor_w)

class Images2Neibs(_ParamDefBase):
    TAG = 3022653556
    __slots__ = ["pad_h", "pad_w", "stride_h", "stride_w", "window_h", "window_w"]
    _packer = struct.Struct("IIIIII0I")
    def __init__(self, pad_h=0, pad_w=0, stride_h=1, stride_w=1, window_h=3, window_w=3):
        """
        :type pad_h: :class:`.int`
        :type pad_w: :class:`.int`
        :type stride_h: :class:`.int`
        :type stride_w: :class:`.int`
        :type window_h: :class:`.int`
        :type window_w: :class:`.int`
        """
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.window_h = int(window_h)
        self.window_w = int(window_w)

class Pooling(_ParamDefBase):
    TAG = 581590217
    class Mode(_EnumBase):
        MAX = "MAX"
        """
        maximum value inside pooling window
        """
        AVERAGE = "AVERAGE"
        """
        arithmetic mean of all values inside pooling window. Padding values are
        taken into account and are viewed as zero
        """
        AVERAGE_COUNT_EXCLUDE_PADDING = "AVERAGE_COUNT_EXCLUDE_PADDING"
        """
        arithmetic mean of all values inside pooling window. No padding isused.
        """
    
    Format = ConvolutionV0.Format
    __slots__ = ["mode", "pad_h", "pad_w", "stride_h", "stride_w", "window_h", "window_w", "format"]
    _packer = struct.Struct("IIIIIIII0I")
    def __init__(self, mode='MAX', pad_h=0, pad_w=0, stride_h=2, stride_w=2, window_h=2, window_w=2, format='NCHW'):
        """
        :type mode: :class:`.Pooling.Mode`
        :type pad_h: :class:`.int`
        :type pad_w: :class:`.int`
        :type stride_h: :class:`.int`
        :type stride_w: :class:`.int`
        :type window_h: :class:`.int`
        :type window_w: :class:`.int`
        :type format: :class:`.ConvolutionV0.Format`
        """
        self.mode = Pooling.Mode.convert(mode)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.window_h = int(window_h)
        self.window_w = int(window_w)
        self.format = ConvolutionV0.Format.convert(format)

class AdaptivePooling(_ParamDefBase):
    TAG = 3024348844
    Mode = Pooling.Mode
    Format = ConvolutionV0.Format
    __slots__ = ["mode", "format"]
    _packer = struct.Struct("II0I")
    def __init__(self, mode='MAX', format='NCHW'):
        """
        :type mode: :class:`.Pooling.Mode`
        :type format: :class:`.ConvolutionV0.Format`
        """
        self.mode = Pooling.Mode.convert(mode)
        self.format = ConvolutionV0.Format.convert(format)

class LRN(_ParamDefBase):
    """
    see ImageNet Classification with Deep Convolutional Neural Networks for
    meaning of the fields
    """
    TAG = 2388216219
    __slots__ = ["n", "k", "alpha", "beta"]
    _packer = struct.Struct("Ifff0I")
    def __init__(self, n=5, k=2., alpha=1e-4, beta=0.75):
        """
        :type n: :class:`.int`
        :param n: must be odd
        :type k: :class:`.float`
        :type alpha: :class:`.float`
        :type beta: :class:`.float`
        """
        self.n = int(n)
        self.k = float(k)
        self.alpha = float(alpha)
        self.beta = float(beta)

class BN(_ParamDefBase):
    TAG = 3765986029
    class ParamDim(_EnumBase):
        DIM_11HW = "DIM_11HW"
        """
        Dim of params (Sigma, Mu) is 1 x 1 x H x W
        """
        DIM_1CHW = "DIM_1CHW"
        """
        Dim of params (Sigma, Mu) is 1 x C x H x W
        """
        DIM_1C11 = "DIM_1C11"
        """
        Dim of params (Sigma, Mu) is 1 x C x 1 x 1
        """
    
    class FwdMode(_EnumBase):
        TRAINING = "TRAINING"
        """
        Training phase.
        """
        INFERENCE = "INFERENCE"
        """
        Inference phase.
        """
    
    __slots__ = ["param_dim", "fwd_mode", "epsilon", "avg_factor", "scale", "bias"]
    _packer = struct.Struct("IIddff0d")
    def __init__(self, param_dim='DIM_11HW', fwd_mode='TRAINING', epsilon=1e-4, avg_factor=1., scale=1., bias=0.):
        """
        :type param_dim: :class:`.BN.ParamDim`
        :type fwd_mode: :class:`.BN.FwdMode`
        :type epsilon: :class:`.float`
        :type avg_factor: :class:`.float`
        :type scale: :class:`.float`
        :type bias: :class:`.float`
        """
        self.param_dim = BN.ParamDim.convert(param_dim)
        self.fwd_mode = BN.FwdMode.convert(fwd_mode)
        self.epsilon = float(epsilon)
        self.avg_factor = float(avg_factor)
        self.scale = float(scale)
        self.bias = float(bias)

class ROIPooling(_ParamDefBase):
    TAG = 111572365
    class Mode(_EnumBase):
        MAX = "MAX"
        """
        maximum value inside pooling window; pooling result would be 0 if
        pooling window is empty
        """
        AVERAGE = "AVERAGE"
        """
        arithmetic mean of all values inside pooling window; pooling result
        would be 0 if pooling window is empty
        """
    
    __slots__ = ["mode", "scale"]
    _packer = struct.Struct("If0I")
    def __init__(self, mode='MAX', scale=1.):
        """
        :type mode: :class:`.ROIPooling.Mode`
        :type scale: :class:`.float`
        """
        self.mode = ROIPooling.Mode.convert(mode)
        self.scale = float(scale)

class WarpPerspective(_ParamDefBase):
    TAG = 3222348414
    class InterpolationMode(_EnumBase):
        NEAREST = "NEAREST"
        LINEAR = "LINEAR"
        AREA = "AREA"
        CUBIC = "CUBIC"
        LANCZOS4 = "LANCZOS4"
        INTER_NEAREST = NEAREST
        INTER_LINEAR = LINEAR
        INTER_AREA = AREA
        INTER_CUBIC = CUBIC
        INTER_LANCZOS4 = LANCZOS4
    
    class BorderMode(_EnumBase):
        REPLICATE = "REPLICATE"
        """
        aaaaaa|abcdefgh|hhhhhhh
        """
        REFLECT = "REFLECT"
        """
        fedcba|abcdefgh|hgfedcb
        """
        REFLECT_101 = "REFLECT_101"
        """
        gfedcb|abcdefgh|gfedcba
        """
        WRAP = "WRAP"
        """
        cdefgh|abcdefgh|abcdefg
        """
        CONSTANT = "CONSTANT"
        """
        iiiiii|abcdefgh|iiiiiii
        """
        TRANSPARENT = "TRANSPARENT"
        ISOLATED = "ISOLATED"
        BORDER_REPLICATE = REPLICATE
        BORDER_REFLECT = REFLECT
        BORDER_REFLECT_101 = REFLECT_101
        BORDER_WRAP = WRAP
        BORDER_CONSTANT = CONSTANT
        BORDER_TRANSPARENT = TRANSPARENT
        BORDER_ISOLATED = ISOLATED
    
    Format = ConvolutionV0.Format
    __slots__ = ["imode", "bmode", "format", "border_val"]
    _packer = struct.Struct("IIIf0I")
    def __init__(self, imode='LINEAR', bmode='REPLICATE', format='NCHW', border_val=.0):
        """
        :type imode: :class:`.WarpPerspective.InterpolationMode`
        :type bmode: :class:`.WarpPerspective.BorderMode`
        :type format: :class:`.ConvolutionV0.Format`
        :type border_val: :class:`.float`
        :param border_val: used for CONSTANT bmode
        """
        self.imode = WarpPerspective.InterpolationMode.convert(imode)
        self.bmode = WarpPerspective.BorderMode.convert(bmode)
        self.format = ConvolutionV0.Format.convert(format)
        self.border_val = float(border_val)

class SpatialTfGridGenerator(_ParamDefBase):
    TAG = 596233615
    class Mode(_EnumBase):
        AFFINE = "AFFINE"
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='AFFINE'):
        """
        :type mode: :class:`.SpatialTfGridGenerator.Mode`
        """
        self.mode = SpatialTfGridGenerator.Mode.convert(mode)

class SpatialTfSampler(_ParamDefBase):
    TAG = 3856477188
    class Mode(_EnumBase):
        BILINEAR = "BILINEAR"
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='BILINEAR'):
        """
        :type mode: :class:`.SpatialTfSampler.Mode`
        """
        self.mode = SpatialTfSampler.Mode.convert(mode)

class AddUpdate(_ParamDefBase):
    TAG = 1017839835
    __slots__ = ["alpha", "beta", "bias"]
    _packer = struct.Struct("fff0f")
    def __init__(self, alpha=1., beta=1., bias=0.):
        """
        :type alpha: :class:`.float`
        :type beta: :class:`.float`
        :type bias: :class:`.float`
        """
        self.alpha = float(alpha)
        self.beta = float(beta)
        self.bias = float(bias)

class Elemwise(_ParamDefBase):
    TAG = 791173831
    class Mode(_EnumBase):
        RELU = "RELU"
        """
        unary: max(x, 0)
        """
        ABS = "ABS"
        """
        unary: abs(x)
        """
        ACOS = "ACOS"
        """
        unary: acos(x)
        """
        ASIN = "ASIN"
        """
        unary: asin(x)
        """
        CEIL = "CEIL"
        """
        unary: ceil(x)
        """
        COS = "COS"
        """
        unary: cos(x)
        """
        EXP = "EXP"
        """
        unary: exp(x)
        """
        EXPM1 = "EXPM1"
        """
        unary: numerically stable exp(x)-1
        """
        FLOOR = "FLOOR"
        """
        unary: floor(x)
        """
        LOG = "LOG"
        """
        unary: natural logarithm, log(x)
        """
        LOG1P = "LOG1P"
        """
        unary: numerically stable log(x+1)
        """
        NEGATE = "NEGATE"
        """
        unary: -x
        """
        SIGMOID = "SIGMOID"
        """
        unary: 1/(1+exp(-x))
        """
        SIN = "SIN"
        """
        unary: sin(x)
        """
        TANH = "TANH"
        """
        unary: tanh(x)
        """
        ABS_GRAD = "ABS_GRAD"
        """
        binary: x > 0 ? y : -y
        """
        ADD = "ADD"
        """
        binary: x + y
        """
        FLOOR_DIV = "FLOOR_DIV"
        """
        binary: floor(x / y)
        """
        MAX = "MAX"
        """
        binary: max(x, y)
        """
        MIN = "MIN"
        """
        binary: min(x, y)
        """
        MOD = "MOD"
        """
        binary: x % y or fmodf(x, y)
        """
        MUL = "MUL"
        """
        binary: x * y
        """
        POW = "POW"
        """
        binary: pow(x, y)
        """
        SIGMOID_GRAD = "SIGMOID_GRAD"
        """
        binary: x * (1 - x) * y
        """
        SUB = "SUB"
        """
        binary: x - y
        """
        SWITCH_GT0 = "SWITCH_GT0"
        """
        binary: (x > 0) * y
        """
        TANH_GRAD = "TANH_GRAD"
        """
        binary: (1 - x * x) * y
        """
        TRUE_DIV = "TRUE_DIV"
        """
        binary: x / y
        """
        LOG_SUM_EXP = "LOG_SUM_EXP"
        """
        binary: numerically stable log(exp(x) + exp(y))
        """
        LT = "LT"
        """
        binary: x < y
        """
        LEQ = "LEQ"
        """
        binary: x <= y
        """
        EQ = "EQ"
        """
        binary: x == y
        """
        SHL = "SHL"
        """
        bitwise binary: x << y. Note that result is undefined if y < 0 or y >=
        bitwidth. Logical shift is performed for unsigned intergers, and
        arithmetic shift for signed ones.
        """
        SHR = "SHR"
        """
        bitwise binary: x >> y; see SHL mode for more details
        """
        COND_LEQ_MOV = "COND_LEQ_MOV"
        """
        ternary: x <= y ? z : 0
        """
        FUSE_MUL_ADD3 = "FUSE_MUL_ADD3"
        """
        compute ``a * b + c`` where c must either have same layout as a or b, or
        be a scalar
        """
        FUSE_MUL_ADD4 = "FUSE_MUL_ADD4"
        """
        compute ``a * A + b * B`` where a and b must have equal layout, and A
        and B must have equal layout. In the inputs ``b`` and ``B`` can be
        swapped
        """
        FUSE_ADD_RELU = "FUSE_ADD_RELU"
        """
        binary: max(x+y, 0)
        """
        FUSE_ADD_SIGMOID = "FUSE_ADD_SIGMOID"
        """
        binary: 1/(1+exp(-(x+y)))
        """
        FUSE_ADD_TANH = "FUSE_ADD_TANH"
        """
        binary: tanh(x+y)
        """
        FAST_TANH = "FAST_TANH"
        """
        unary: rational approximation of tanh(x)
        """
        FAST_TANH_GRAD = "FAST_TANH_GRAD"
        """
        binary: grad of the rational approximation of tanh(x)
        """
        ROUND = "ROUND"
        """
        unary: round(x), the nearest integer value to x, rounding halfway cases
        away from zero. Float only.
        """
        RMULH = "RMULH"
        """
        binary: rounded higher l bits of x * y, where l is the bit length of x.
        """
        ATAN2 = "ATAN2"
        """
        binary: atan2(y,x)
        """
        ERF = "ERF"
        """
        unary: erf(x)
        """
        ERFINV = "ERFINV"
        """
        unary: inverse function of erf(x)
        """
        ERFC = "ERFC"
        """
        unary: erfc(x)
        """
        ERFCINV = "ERFCINV"
        """
        unary: inverse function of erfc(x)
        """
        H_SWISH = "H_SWISH"
        """
        unary: x * clip(x + 3, 0, 6) / 6
        """
        H_SWISH_GRAD = "H_SWISH_GRAD"
        """
        binary: x < -3 ? 0 : (x > 3 ? y : (2 * x + 3) / 6 * y)
        """
        FUSE_ADD_H_SWISH = "FUSE_ADD_H_SWISH"
        """
        binary: hswish(x+y)
        """
        NOT = "NOT"
        """
        unary: !x
        """
        AND = "AND"
        """
        binary: x && y
        """
        OR = "OR"
        """
        binary: x || y
        """
        XOR = "XOR"
        """
        binary: x ^ y
        """
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='RELU'):
        """
        :type mode: :class:`.Elemwise.Mode`
        """
        self.mode = Elemwise.Mode.convert(mode)

class ElemwiseMultiType(_ParamDefBase):
    TAG = 139916022
    class Mode(_EnumBase):
        FUSE_MUL_ADD3_INT16x32x32x32 = "FUSE_MUL_ADD3_INT16x32x32x32"
        """
        compute ``a * b + c`` requiring that ``a`` be int16 and ``b`` and ``c``
        int32, and the result is int32. This mode is optimized for the channel-
        broadacsted case, i.e. ``a`` has shape (A, B, C) and ``b`` and ``c``
        have shape (1, C, 1)
        """
        FUSE_MUL_ADD3_IXxF32xF32xI8 = "FUSE_MUL_ADD3_IXxF32xF32xI8"
        """
        compuate ``a * b + c`` where the inputs ``a`` is an integer type ``b``
        and ``c`` are both ``float32``, the result is ``int8``. This is
        currently only optimized for ``(1, x)`` broadcast for ``b`` and ``c``.
        Computation is carried in floating points and results are rounded
        towards zero with saturated cast to int.
        """
        ROUND_SHR_SATURATE_IXxI8xI8 = "ROUND_SHR_SATURATE_IXxI8xI8"
        """
        Compute ``a >> b``, round the result according to lower ``b`` bits of
        ``a``` and make a saturating conversion to int8. Where ``a`` should be
        an integer tensor and ``b`` should be an int8 scalar.
        """
        FUSE_ADD_RMULH_ROUND_SHR_SATURATE_INT16x16x16x8 = "FUSE_ADD_RMULH_ROUND_SHR_SATURATE_INT16x16x16x8"
        """
        Fused operation of an int16 elemwise add, an int16 rounding multiply
        high and an int16 to int8 rounding right shift with saturation.
        """
        FUSE_ADD_RMULH_ROUND_SHR_SATURATE_INT32x32x32x8 = "FUSE_ADD_RMULH_ROUND_SHR_SATURATE_INT32x32x32x8"
        """
        Fused operation of an int32 elemwise add, an int32 rounding multiply
        high and an int32 to int8 rounding right shift with saturation.
        """
        ROUND_SHR_SATURATE_IXxI8xI16 = "ROUND_SHR_SATURATE_IXxI8xI16"
        """
        Compute ``a >> b``, round the result according to lower ``b`` bits of
        ``a``` and make a saturating conversion to int16. Where ``a`` should be
        an integer tensor and ``b`` should be an int8 scalar.
        """
        QADD = "QADD"
        """
        Fused elemwise add two quantized int8 with specifiedoutput quantized
        dtype
        """
        QFUSE_ADD_RELU = "QFUSE_ADD_RELU"
        """
        Fused elemwise add two quantized int8 followed by ReLU and typecvt to
        specified dtype
        """
        QMUL = "QMUL"
        """
        Fused elemwise multiply two quantized int8 with specifiedoutput
        quantized dtype
        """
        QMIN = "QMIN"
        """
        Fused elemwise min two quantized int8 with specifiedoutput quantized
        dtype
        """
        QMAX = "QMAX"
        """
        quantized: max(x, y), with specified output quantized dtype
        """
        QSUB = "QSUB"
        """
        quantized: x - y
        """
        QTRUE_DIV = "QTRUE_DIV"
        """
        quantized: x / y
        """
        QFUSE_ADD_SIGMOID = "QFUSE_ADD_SIGMOID"
        """
        quantized: sigmoid(x + y)
        """
        QFUSE_ADD_TANH = "QFUSE_ADD_TANH"
        """
        quantized: tanh(x + y)
        """
        QRELU = "QRELU"
        """
        quantized: x > 0 ? x : 0
        """
        QABS = "QABS"
        """
        quantized: x > 0 ? x : -x
        """
        QSIGMOID = "QSIGMOID"
        """
        quantized: sigmoid(x)
        """
        QEXP = "QEXP"
        """
        quantized: exp(x)
        """
        QTANH = "QTANH"
        """
        quantized: tanh(x)
        """
        QFUSE_MUL_ADD3 = "QFUSE_MUL_ADD3"
        """
        quantized: x * y + z
        """
        QFAST_TANH = "QFAST_TANH"
        """
        quantized: fast_tanh(x)
        """
        QNEGATE = "QNEGATE"
        """
        quantized: -x
        """
        QACOS = "QACOS"
        """
        quantized: acos(x)
        """
        QASIN = "QASIN"
        """
        quantized: asin(x)
        """
        QCEIL = "QCEIL"
        """
        quantized: ceil(x)
        """
        QCOS = "QCOS"
        """
        quantized: cos(x)
        """
        QEXPM1 = "QEXPM1"
        """
        quantized: expm1(x)
        """
        QFLOOR = "QFLOOR"
        """
        quantized: floor(x)
        """
        QLOG = "QLOG"
        """
        quantized: log(x)
        """
        QLOG1P = "QLOG1P"
        """
        quantized: log1p(x)
        """
        QSIN = "QSIN"
        """
        quantized: sin(x)
        """
        QROUND = "QROUND"
        """
        quantized: round(x)
        """
        QERF = "QERF"
        """
        quantized: erf(x)
        """
        QERFINV = "QERFINV"
        """
        quantized: erfinv(x)
        """
        QERFC = "QERFC"
        """
        quantized: erfc(x)
        """
        QERFCINV = "QERFCINV"
        """
        quantized: erfcinv(x)
        """
        QABS_GRAD = "QABS_GRAD"
        """
        quantized: abs_grad
        """
        QFLOOR_DIV = "QFLOOR_DIV"
        """
        quantized floor_div
        """
        QMOD = "QMOD"
        """
        quantized mod
        """
        QSIGMOID_GRAD = "QSIGMOID_GRAD"
        """
        quantized sigmoid_grad
        """
        QSWITCH_GT0 = "QSWITCH_GT0"
        """
        quantized switch_gt0
        """
        QTANH_GRAD = "QTANH_GRAD"
        """
        quantized tanh_grad
        """
        QLT = "QLT"
        """
        quantized lt
        """
        QLEQ = "QLEQ"
        """
        quantized leq
        """
        QEQ = "QEQ"
        """
        quantized eq
        """
        QPOW = "QPOW"
        """
        quantized pow
        """
        QLOG_SUM_EXP = "QLOG_SUM_EXP"
        """
        quantized log_sum_exp
        """
        QFAST_TANH_GRAD = "QFAST_TANH_GRAD"
        """
        quantized fast_tanh_grad
        """
        QATAN2 = "QATAN2"
        """
        quantized atan2
        """
        QCOND_LEQ_MOV = "QCOND_LEQ_MOV"
        """
        quantized cond_leq_mov
        """
        QH_SWISH = "QH_SWISH"
        """
        quantized h_swish
        """
        QFUSE_ADD_H_SWISH = "QFUSE_ADD_H_SWISH"
        """
        quantized h_swish(x+y)
        """
        QH_SWISH_GRAD = "QH_SWISH_GRAD"
        """
        quantized h_swish_grad
        """
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='FUSE_MUL_ADD3_INT16x32x32x32'):
        """
        :type mode: :class:`.ElemwiseMultiType.Mode`
        """
        self.mode = ElemwiseMultiType.Mode.convert(mode)

class PowC(_ParamDefBase):
    """
    power with constant exponent
    """
    TAG = 688442896
    __slots__ = ["exp"]
    _packer = struct.Struct("f0f")
    def __init__(self, exp=0):
        """
        :type exp: :class:`.float`
        """
        self.exp = float(exp)

class MatrixMulV0(_ParamDefBase):
    TAG = 2382437341
    class DataType(_EnumBase):
        FLOAT = "FLOAT"
        """
        input/output both float32/float16
        """
        INT8x8x16 = "INT8x8x16"
        INT8x8x32 = "INT8x8x32"
        FLOAT_IO16xC32 = "FLOAT_IO16xC32"
        """
        input/output both float16, the internal compute is float32
        """
        QUINT8x8x32 = "QUINT8x8x32"
        """
        input QuantizedAsymm8, output QuantizedS32
        """
        QUINT4x4x32 = "QUINT4x4x32"
        """
        input QuantizedAsymm4, output QuantizedS32
        """
    
    __slots__ = ["transposeA", "transposeB", "data_type"]
    _packer = struct.Struct("??I0I")
    def __init__(self, transposeA=False, transposeB=False, data_type='FLOAT'):
        """
        :type transposeA: :class:`.bool`
        :type transposeB: :class:`.bool`
        :type data_type: :class:`.MatrixMulV0.DataType`
        """
        self.transposeA = bool(transposeA)
        self.transposeB = bool(transposeB)
        self.data_type = MatrixMulV0.DataType.convert(data_type)

class MatrixMulV1(_ParamDefBase):
    TAG = 751228537
    class ComputeMode(_EnumBase):
        """
        Specifies special computation modes, e.g. different combinations of
        intermediate result data types.
        """
        DEFAULT = "DEFAULT"
        """
        No special requirements on the precision of intermediate results.
        """
        FLOAT32 = "FLOAT32"
        """
        Use Float32 accumulator and intermediate result. Only supported when
        input and output is Float16.
        """
    
    __slots__ = ["transposeA", "transposeB", "compute_mode"]
    _packer = struct.Struct("??I0I")
    def __init__(self, transposeA=False, transposeB=False, compute_mode='DEFAULT'):
        """
        :type transposeA: :class:`.bool`
        :type transposeB: :class:`.bool`
        :type compute_mode: :class:`.MatrixMulV1.ComputeMode`
        """
        self.transposeA = bool(transposeA)
        self.transposeB = bool(transposeB)
        self.compute_mode = MatrixMulV1.ComputeMode.convert(compute_mode)

class MatrixMul(_ParamDefBase):
    TAG = 2799239548
    ComputeMode = MatrixMulV1.ComputeMode
    class Format(_EnumBase):
        DEFAULT = "DEFAULT"
        """
        Normal matrix mul: (M, K) x (K, N) = (M, N)
        """
        MK4 = "MK4"
        """
        Split 4 from M and K, better for neon compute:(M/4, K/4, 4(k), 4(m)) x
        (K/4, N, 4(k)). if transposeA the layout is (K/4, M/4, 4(k), 4(m)) x
        (K/4, N, 4(k))
        """
        MK8 = "MK8"
        """
        Split 8 from M and K, better for neon compute:(M/8, K/8, 8(k), 8(m)) x
        (K/8, N, 8(k)). if transposeA the layout is (K/8, M/8, 8(k), 8(m)) x
        (K/8, N, 8(k))
        """
        MK4_DOT = "MK4_DOT"
        """
        Split 4 from M and K, better for neon dotprod:M/4, K/4, 4(m), 4(k)) x
        (K/4, N, 4(k)). if transposeA the layout is (K/4, M/4, 4(m), 4(k)) x
        (K/4, N, 4(k))
        """
    
    __slots__ = ["transposeA", "transposeB", "compute_mode", "format"]
    _packer = struct.Struct("??II0I")
    def __init__(self, transposeA=False, transposeB=False, compute_mode='DEFAULT', format='DEFAULT'):
        """
        :type transposeA: :class:`.bool`
        :type transposeB: :class:`.bool`
        :type compute_mode: :class:`.MatrixMulV1.ComputeMode`
        :type format: :class:`.MatrixMul.Format`
        """
        self.transposeA = bool(transposeA)
        self.transposeB = bool(transposeB)
        self.compute_mode = MatrixMulV1.ComputeMode.convert(compute_mode)
        self.format = MatrixMul.Format.convert(format)

class Winograd(_ParamDefBase):
    """
    winograd param used in convbias
    """
    TAG = 293958225
    Format = MatrixMul.Format
    ComputeMode = Convolution.ComputeMode
    __slots__ = ["output_block_size", "format", "compute_mode"]
    _packer = struct.Struct("III0I")
    def __init__(self, output_block_size=0, format='DEFAULT', compute_mode='DEFAULT'):
        """
        :type output_block_size: :class:`.int`
        :param output_block_size: output block size, detail meaning see winograd in convbias, equals to the meaning of m in F(m, r)
        :type format: :class:`.MatrixMul.Format`
        :type compute_mode: :class:`.Convolution.ComputeMode`
        """
        self.output_block_size = int(output_block_size)
        self.format = MatrixMul.Format.convert(format)
        self.compute_mode = Convolution.ComputeMode.convert(compute_mode)

class SVD(_ParamDefBase):
    TAG = 3024195679
    __slots__ = ["full_matrices", "compute_uv"]
    _packer = struct.Struct("??0?")
    def __init__(self, full_matrices=False, compute_uv=True):
        """
        :type full_matrices: :class:`.bool`
        :param full_matrices: Whether to compute the full-sized u and v or only the leading min(m, n) singular vectors. Ignored if compute_uv is false.
        :type compute_uv: :class:`.bool`
        :param compute_uv: Whether the left (u) and right (v) singular vectors will be computed and outputted.
        """
        self.full_matrices = bool(full_matrices)
        self.compute_uv = bool(compute_uv)

class ReduceV0(_ParamDefBase):
    """
    legacy reduce
    """
    TAG = 1111565944
    class Mode(_EnumBase):
        SUM = "SUM"
        SUM_SQR = "SUM_SQR"
        """
        sum of x * x for each element x
        """
        PRODUCT = "PRODUCT"
        MIN = "MIN"
        MAX = "MAX"
    
    __slots__ = ["mode", "axis"]
    _packer = struct.Struct("Ii0I")
    def __init__(self, mode='SUM', axis=-1):
        """
        :type mode: :class:`.ReduceV0.Mode`
        :type axis: :class:`.int`
        :param axis: axis along which reduction is performed; if -1 is given, reduce to given target shape (only used in megbrain)
        """
        self.mode = ReduceV0.Mode.convert(mode)
        self.axis = int(axis)

class ReduceV1(_ParamDefBase):
    """
    reduce along given axis
    """
    TAG = 229533304
    class Mode(_EnumBase):
        SUM = "SUM"
        SUM_SQR = "SUM_SQR"
        """
        sum of x * x for each element x
        """
        PRODUCT = "PRODUCT"
        MIN = "MIN"
        MAX = "MAX"
        MEAN = "MEAN"
    
    class DataType(_EnumBase):
        DEFAULT = "DEFAULT"
        """
        input/output are the same data type, and the internal computation type would be chosen by the input/output dtypes and the reduction mode.
        Currently, ```DEFAULT``` mode means:
        
        +--------------------+-----------------------------------+-------------------+
        | Input/Output DType | Mode                              | Computation DType |
        +====================+===================================+===================+
        | FLOAT32            | MIN/MAX/MEAN/SUM/SUM_SQR/PRODUCT  | FLOAT32           |
        +--------------------+-----------------------------------+-------------------+
        | FLOAT16            | MIN/MAX/MEAN/SUM/SUM_SQR/PRODUCT  | FLOAT16           |
        +--------------------+-----------------------------------+-------------------+
        | INT32              | MIN/MAX/MEAN/SUM/SUM_SQR/PRODUCT  | INT32             |
        +--------------------+-----------------------------------+-------------------+
        | INT8               | MIN/MAX/MEAN/SUM/SUM_SQR/PRODUCT  | INT8              |
        +--------------------+-----------------------------------+-------------------+
        | QuantizedS8        | MIN/MAX                           | QuantizedS8       |
        +--------------------+-----------------------------------+-------------------+
        | QuantizedS8        | MEAN/SUM                          | QuantizedS32      |
        +--------------------+-----------------------------------+-------------------+
        | Quantized8Asymm    | MIN/MAX                           | Quantized8Asymm   |
        +--------------------+-----------------------------------+-------------------+
        | Quantized8Asymm    | MEAN/SUM                          | QuantizedS32      |
        +--------------------+-----------------------------------+-------------------+
        
        
        """
        FLOAT_IO16xC32 = "FLOAT_IO16xC32"
        """
        Deprecated. This was replaced by FLOAT_O16xC32, and input's dtype
        decided by actual input tensor.
        """
        FLOAT_O32xC32 = "FLOAT_O32xC32"
        """
        compute/output both are float32
        """
        FLOAT_O16xC32 = "FLOAT_O16xC32"
        """
        compute are float32, output float16
        """
        QUINT_I8xO32 = "QUINT_I8xO32"
        """
        input quint8, compute and output are qint32
        """
        QINT_I8xO32 = "QINT_I8xO32"
        """
        input qint8, compute and output are qint32
        """
    
    __slots__ = ["mode", "axis", "data_type"]
    _packer = struct.Struct("IiI0I")
    def __init__(self, mode='SUM', axis=-1, data_type='DEFAULT'):
        """
        :type mode: :class:`.ReduceV1.Mode`
        :type axis: :class:`.int`
        :param axis: axis along which reduction is performed; if -1 is given, reduce to given target shape (only used in megbrain)
        :type data_type: :class:`.ReduceV1.DataType`
        """
        self.mode = ReduceV1.Mode.convert(mode)
        self.axis = int(axis)
        self.data_type = ReduceV1.DataType.convert(data_type)

class Reduce(_ParamDefBase):
    """
    reduce along given axis
    """
    TAG = 1246642972
    class Mode(_EnumBase):
        SUM = "SUM"
        SUM_SQR = "SUM_SQR"
        """
        sum of x * x for each element x
        """
        PRODUCT = "PRODUCT"
        MIN = "MIN"
        MAX = "MAX"
        MEAN = "MEAN"
    
    class DataType(_EnumBase):
        DEFAULT = "DEFAULT"
        """
        input/output are the same data type, and the internal computation type would be chosen by the input/output dtypes and the reduction mode.
        Currently, ```DEFAULT``` mode means:
        
        +--------------------+-----------------------------------+-------------------+
        | Input/Output DType | Mode                              | Computation DType |
        +====================+===================================+===================+
        | FLOAT32            | MIN/MAX/MEAN/SUM/SUM_SQR/PRODUCT  | FLOAT32           |
        +--------------------+-----------------------------------+-------------------+
        | FLOAT16            | MIN/MAX/MEAN/SUM/SUM_SQR/PRODUCT  | FLOAT16           |
        +--------------------+-----------------------------------+-------------------+
        | INT32              | MIN/MAX/MEAN/SUM/SUM_SQR/PRODUCT  | INT32             |
        +--------------------+-----------------------------------+-------------------+
        | INT8               | MIN/MAX/MEAN/SUM/SUM_SQR/PRODUCT  | INT8              |
        +--------------------+-----------------------------------+-------------------+
        | QuantizedS8        | MIN/MAX                           | QuantizedS8       |
        +--------------------+-----------------------------------+-------------------+
        | QuantizedS8        | MEAN/SUM                          | QuantizedS32      |
        +--------------------+-----------------------------------+-------------------+
        | Quantized8Asymm    | MIN/MAX                           | Quantized8Asymm   |
        +--------------------+-----------------------------------+-------------------+
        | Quantized8Asymm    | MEAN/SUM                          | QuantizedS32      |
        +--------------------+-----------------------------------+-------------------+
        
        
        """
        FLOAT_IO16xC32 = "FLOAT_IO16xC32"
        """
        Deprecated. This was replaced by FLOAT_O16xC32, and input's dtype
        decided by actual input tensor.
        """
        FLOAT_O32xC32 = "FLOAT_O32xC32"
        """
        compute/output both are float32
        """
        FLOAT_O16xC32 = "FLOAT_O16xC32"
        """
        compute are float32, output float16
        """
        QUINT_I8xO32 = "QUINT_I8xO32"
        """
        input quint8, compute and output are qint32
        """
        QINT_I8xO32 = "QINT_I8xO32"
        """
        input qint8, compute and output are qint32
        """
    
    __slots__ = ["mode", "axis", "data_type"]
    _packer = struct.Struct("IiI0I")
    def __init__(self, mode='SUM', axis=2147483647, data_type='DEFAULT'):
        """
        :type mode: :class:`.Reduce.Mode`
        :type axis: :class:`.int`
        :param axis: axis along which reduction is performed; if INT_MAX is given, reduce to given target shape (only used in megbrain)
        :type data_type: :class:`.Reduce.DataType`
        """
        self.mode = Reduce.Mode.convert(mode)
        self.axis = int(axis)
        self.data_type = Reduce.DataType.convert(data_type)

class CumsumV0(_ParamDefBase):
    """
    calculate accumulated sum along given axis
    """
    TAG = 1887071490
    __slots__ = ["axis", "exclusive", "reverse"]
    _packer = struct.Struct("i??0i")
    def __init__(self, axis=-1, exclusive=True, reverse=False):
        """
        :type axis: :class:`.int`
        :param axis: axis along which cumsum is performed
        :type exclusive: :class:`.bool`
        :param exclusive: whether the current element is taken into account
        :type reverse: :class:`.bool`
        :param reverse: whether the cumsum is forward or backward
        """
        self.axis = int(axis)
        self.exclusive = bool(exclusive)
        self.reverse = bool(reverse)

class Cumsum(_ParamDefBase):
    """
    calculate accumulated sum along given axis
    """
    TAG = 774078408
    __slots__ = ["axis", "exclusive", "reverse"]
    _packer = struct.Struct("i??0i")
    def __init__(self, axis=2147483647, exclusive=True, reverse=False):
        """
        :type axis: :class:`.int`
        :param axis: axis along which cumsum is performed, default with INT_MAX
        :type exclusive: :class:`.bool`
        :param exclusive: whether the current element is taken into account
        :type reverse: :class:`.bool`
        :param reverse: whether the cumsum is forward or backward
        """
        self.axis = int(axis)
        self.exclusive = bool(exclusive)
        self.reverse = bool(reverse)

class CondTake(_ParamDefBase):
    TAG = 734043720
    class Mode(_EnumBase):
        EQ = "EQ"
        """
        take if ``abs(data-val)<eps``
        """
        NEQ = "NEQ"
        """
        take if ``abs(data-val)>=eps``
        """
        LT = "LT"
        """
        take if ``data<val``
        """
        LEQ = "LEQ"
        """
        take if ``data<=val``
        """
        GT = "GT"
        """
        take if ``data>val``
        """
        GEQ = "GEQ"
        """
        take if ``data>=val``
        """
    
    __slots__ = ["mode", "val", "eps"]
    _packer = struct.Struct("Iff0I")
    def __init__(self, mode='EQ', val=0, eps=1e-06):
        """
        :type mode: :class:`.CondTake.Mode`
        :type val: :class:`.float`
        :param val: the value to be compared with; note that for integer data, val is also converted to int
        :type eps: :class:`.float`
        :param eps: used for float equality comparison
        """
        self.mode = CondTake.Mode.convert(mode)
        self.val = float(val)
        self.eps = float(eps)

class Argsort(_ParamDefBase):
    TAG = 2993639216
    class Order(_EnumBase):
        ASCENDING = "ASCENDING"
        DESCENDING = "DESCENDING"
    
    __slots__ = ["order"]
    _packer = struct.Struct("I0I")
    def __init__(self, order='ASCENDING'):
        """
        :type order: :class:`.Argsort.Order`
        """
        self.order = Argsort.Order.convert(order)

class IndexingRemap(_ParamDefBase):
    TAG = 3137589921
    __slots__ = ["is_non_overlapping"]
    _packer = struct.Struct("?0?")
    def __init__(self, is_non_overlapping=False):
        """
        :type is_non_overlapping: :class:`.bool`
        :param is_non_overlapping: Whether no two dst element maps to the same src element. Enabling this option can accelerate gradient operator since atomic adding operations could be avoided.
        """
        self.is_non_overlapping = bool(is_non_overlapping)

class Sleep(_ParamDefBase):
    TAG = 3563502837
    __slots__ = ["time"]
    _packer = struct.Struct("f0f")
    def __init__(self, time=0):
        """
        :type time: :class:`.float`
        :param time: time to sleep in seconds
        """
        self.time = float(time)

class Linspace(_ParamDefBase):
    TAG = 616024820
    __slots__ = ["endpoint"]
    _packer = struct.Struct("?0?")
    def __init__(self, endpoint=True):
        """
        :type endpoint: :class:`.bool`
        :param endpoint: Whether stop is included in the generated tensor
        """
        self.endpoint = bool(endpoint)

class LinspaceFull(_ParamDefBase):
    TAG = 1318409902
    __slots__ = ["start", "stop", "endpoint"]
    _packer = struct.Struct("dd?0d")
    def __init__(self, start=0, stop=1, endpoint=True):
        """
        :type start: :class:`.float`
        :param start: The first val.
        :type stop: :class:`.float`
        :param stop: The last val.
        :type endpoint: :class:`.bool`
        :param endpoint: Whether stop is included in the generated tensor
        """
        self.start = float(start)
        self.stop = float(stop)
        self.endpoint = bool(endpoint)

class Eye(_ParamDefBase):
    TAG = 3471011925
    __slots__ = ["k", "dtype"]
    _packer = struct.Struct("iI0i")
    def __init__(self, k=0, dtype="float32"):
        """
        :type k: :class:`.int`
        :param k: Index of the diagonal: 0 (the default) refers to the main diagonal, a positive value refers to an upper diagonal, and a negative value to a lower diagonal.
        :type dtype: :class:`._as_dtype_num`
        :param dtype: data type of output value
        """
        self.k = int(k)
        self.dtype = _as_dtype_num(dtype)

class UniformRNG(_ParamDefBase):
    TAG = 379446398
    __slots__ = ["seed"]
    _packer = struct.Struct("Q0Q")
    def __init__(self, seed=0):
        """
        :type seed: :class:`.int`
        """
        self.seed = int(seed)

class GaussianRNG(_ParamDefBase):
    TAG = 1035599260
    __slots__ = ["seed", "mean", "std"]
    _packer = struct.Struct("Qff0Q")
    def __init__(self, seed=0, mean=0, std=1):
        """
        :type seed: :class:`.int`
        :type mean: :class:`.float`
        :type std: :class:`.float`
        """
        self.seed = int(seed)
        self.mean = float(mean)
        self.std = float(std)

class Flip(_ParamDefBase):
    TAG = 608817463
    __slots__ = ["vertical", "horizontal"]
    _packer = struct.Struct("??0?")
    def __init__(self, vertical=False, horizontal=False):
        """
        :type vertical: :class:`.bool`
        :type horizontal: :class:`.bool`
        """
        self.vertical = bool(vertical)
        self.horizontal = bool(horizontal)

class Rotate(_ParamDefBase):
    TAG = 3277929239
    __slots__ = ["clockwise"]
    _packer = struct.Struct("?0?")
    def __init__(self, clockwise=True):
        """
        :type clockwise: :class:`.bool`
        """
        self.clockwise = bool(clockwise)

class ROICopy(_ParamDefBase):
    TAG = 2619888986
    __slots__ = ["row_from", "row_to", "col_from", "col_to"]
    _packer = struct.Struct("IIII0I")
    def __init__(self, row_from=0, row_to=0, col_from=0, col_to=0):
        """
        :type row_from: :class:`.int`
        :type row_to: :class:`.int`
        :type col_from: :class:`.int`
        :type col_to: :class:`.int`
        """
        self.row_from = int(row_from)
        self.row_to = int(row_to)
        self.col_from = int(col_from)
        self.col_to = int(col_to)

class CvtColor(_ParamDefBase):
    TAG = 1364268694
    class Mode(_EnumBase):
        RGB2GRAY = "RGB2GRAY"
        RGB2YUV = "RGB2YUV"
        YUV2RGB = "YUV2RGB"
        GRAY2RGB = "GRAY2RGB"
        RGBA2RGB = "RGBA2RGB"
        RGBA2BGR = "RGBA2BGR"
        RGBA2GRAY = "RGBA2GRAY"
        RGB2BGR = "RGB2BGR"
        BGR2GRAY = "BGR2GRAY"
        BGR2RGB = "BGR2RGB"
        YUV2GRAY_NV21 = "YUV2GRAY_NV21"
        """
        For historical reasons, referred to as YCC by opencv
        """
        YUV2RGB_NV21 = "YUV2RGB_NV21"
        YUV2BGR_NV21 = "YUV2BGR_NV21"
        YUV2GRAY_NV12 = "YUV2GRAY_NV12"
        YUV2RGB_NV12 = "YUV2RGB_NV12"
        YUV2BGR_NV12 = "YUV2BGR_NV12"
        YUV2GRAY_YV12 = "YUV2GRAY_YV12"
        YUV2RGB_YV12 = "YUV2RGB_YV12"
        YUV2BGR_YV12 = "YUV2BGR_YV12"
        YUV2GRAY_YU12 = "YUV2GRAY_YU12"
        YUV2RGB_YU12 = "YUV2RGB_YU12"
        YUV2BGR_YU12 = "YUV2BGR_YU12"
        YCrCb2RGB = "YCrCb2RGB"
        YCrCb2BGR = "YCrCb2BGR"
        BT601_YUV2RGB_NV21 = "BT601_YUV2RGB_NV21"
        """
        BT601 yuv format, referred to as YUV by opencv
        """
        BT601_YUV2BGR_NV21 = "BT601_YUV2BGR_NV21"
        BT601_YUV2RGB_NV12 = "BT601_YUV2RGB_NV12"
        BT601_YUV2BGR_NV12 = "BT601_YUV2BGR_NV12"
        BT601_YUV2RGB_YV12 = "BT601_YUV2RGB_YV12"
        BT601_YUV2BGR_YV12 = "BT601_YUV2BGR_YV12"
        BT601_YUV2RGB_YU12 = "BT601_YUV2RGB_YU12"
        BT601_YUV2BGR_YU12 = "BT601_YUV2BGR_YU12"
        BT601_YUV2GRAY_NV21 = YUV2GRAY_NV21
        BT601_YUV2GRAY_NV12 = YUV2GRAY_NV12
        BT601_YUV2GRAY_YV12 = YUV2GRAY_YV12
        BT601_YUV2GRAY_YU12 = YUV2GRAY_YU12
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='RGB2GRAY'):
        """
        :type mode: :class:`.CvtColor.Mode`
        """
        self.mode = CvtColor.Mode.convert(mode)

class WarpAffineV0(_ParamDefBase):
    TAG = 1507366749
    InterpolationMode = WarpPerspective.InterpolationMode
    BorderMode = WarpPerspective.BorderMode
    __slots__ = ["imode", "border_mode", "border_val"]
    _packer = struct.Struct("IIf0I")
    def __init__(self, imode='LINEAR', border_mode='REPLICATE', border_val=.0):
        """
        :type imode: :class:`.WarpPerspective.InterpolationMode`
        :type border_mode: :class:`.WarpPerspective.BorderMode`
        :type border_val: :class:`.float`
        :param border_val: used for CONSTANT bmode
        """
        self.imode = WarpPerspective.InterpolationMode.convert(imode)
        self.border_mode = WarpPerspective.BorderMode.convert(border_mode)
        self.border_val = float(border_val)

class WarpAffine(_ParamDefBase):
    TAG = 3653482822
    InterpolationMode = WarpPerspective.InterpolationMode
    BorderMode = WarpPerspective.BorderMode
    Format = ConvolutionV0.Format
    __slots__ = ["imode", "border_mode", "border_val", "format"]
    _packer = struct.Struct("IIfI0I")
    def __init__(self, imode='LINEAR', border_mode='REPLICATE', border_val=.0, format='NHWC'):
        """
        :type imode: :class:`.WarpPerspective.InterpolationMode`
        :type border_mode: :class:`.WarpPerspective.BorderMode`
        :type border_val: :class:`.float`
        :param border_val: used for CONSTANT bmode
        :type format: :class:`.ConvolutionV0.Format`
        """
        self.imode = WarpPerspective.InterpolationMode.convert(imode)
        self.border_mode = WarpPerspective.BorderMode.convert(border_mode)
        self.border_val = float(border_val)
        self.format = ConvolutionV0.Format.convert(format)

class GaussianBlur(_ParamDefBase):
    TAG = 3213149798
    BorderMode = WarpPerspective.BorderMode
    __slots__ = ["border_mode", "kernel_height", "kernel_width", "sigma_x", "sigma_y"]
    _packer = struct.Struct("IIIff0I")
    def __init__(self, border_mode='REPLICATE', kernel_height=0, kernel_width=0, sigma_x=0., sigma_y=0.):
        """
        :type border_mode: :class:`.WarpPerspective.BorderMode`
        :type kernel_height: :class:`.int`
        :type kernel_width: :class:`.int`
        :type sigma_x: :class:`.float`
        :type sigma_y: :class:`.float`
        """
        self.border_mode = WarpPerspective.BorderMode.convert(border_mode)
        self.kernel_height = int(kernel_height)
        self.kernel_width = int(kernel_width)
        self.sigma_x = float(sigma_x)
        self.sigma_y = float(sigma_y)

class ResizeV0(_ParamDefBase):
    TAG = 693559402
    InterpolationMode = WarpPerspective.InterpolationMode
    __slots__ = ["imode"]
    _packer = struct.Struct("I0I")
    def __init__(self, imode='LINEAR'):
        """
        :type imode: :class:`.WarpPerspective.InterpolationMode`
        """
        self.imode = WarpPerspective.InterpolationMode.convert(imode)

class Resize(_ParamDefBase):
    TAG = 31792670
    InterpolationMode = WarpPerspective.InterpolationMode
    Format = ConvolutionV0.Format
    __slots__ = ["imode", "format"]
    _packer = struct.Struct("II0I")
    def __init__(self, imode='LINEAR', format='NHWC'):
        """
        :type imode: :class:`.WarpPerspective.InterpolationMode`
        :type format: :class:`.ConvolutionV0.Format`
        """
        self.imode = WarpPerspective.InterpolationMode.convert(imode)
        self.format = ConvolutionV0.Format.convert(format)

class Remap(_ParamDefBase):
    TAG = 3129834253
    InterpolationMode = WarpPerspective.InterpolationMode
    BorderMode = WarpPerspective.BorderMode
    Format = ConvolutionV0.Format
    __slots__ = ["imode", "border_type", "format", "scalar"]
    _packer = struct.Struct("IIIf0I")
    def __init__(self, imode='LINEAR', border_type='REPLICATE', format='NHWC', scalar=0.):
        """
        :type imode: :class:`.WarpPerspective.InterpolationMode`
        :type border_type: :class:`.WarpPerspective.BorderMode`
        :type format: :class:`.ConvolutionV0.Format`
        :type scalar: :class:`.float`
        """
        self.imode = WarpPerspective.InterpolationMode.convert(imode)
        self.border_type = WarpPerspective.BorderMode.convert(border_type)
        self.format = ConvolutionV0.Format.convert(format)
        self.scalar = float(scalar)

class Convolution3D(_ParamDefBase):
    TAG = 3027053684
    class Mode(_EnumBase):
        CROSS_CORRELATION = "CROSS_CORRELATION"
        CONVOLUTION = "CONVOLUTION"
    
    class Sparse(_EnumBase):
        DENSE = "DENSE"
        """
        dense convolution: filter shape should be [oc, ic, spatial...] if format
        is NCDHW, [oc, spatial..., ic] if format is NDHWC
        """
        GROUP = "GROUP"
        """
        group convolution: filter shape should be [group, oc_per_group,
        ic_per_group, spatial...] if format is NCDHW, [group, oc_per_group,
        spatial..., ic_per_group] if format is NDHWC
        """
    
    class DataType(_EnumBase):
        FLOAT = "FLOAT"
        """
        input/output both float32/float16
        """
        FLOAT_IO16xC32 = "FLOAT_IO16xC32"
        """
        input/output both float16, the internal compute is float32
        """
    
    class Format(_EnumBase):
        NCDHW = "NCDHW"
        NDHWC = "NDHWC"
    
    __slots__ = ["mode", "pad_d", "pad_h", "pad_w", "stride_d", "stride_h", "stride_w", "dilate_d", "dilate_h", "dilate_w", "sparse", "data_type", "format"]
    _packer = struct.Struct("IIIIIIIIIIIII0I")
    def __init__(self, mode='CROSS_CORRELATION', pad_d=0, pad_h=0, pad_w=0, stride_d=1, stride_h=1, stride_w=1, dilate_d=1, dilate_h=1, dilate_w=1, sparse='DENSE', data_type='FLOAT', format='NCDHW'):
        """
        :type mode: :class:`.Convolution3D.Mode`
        :type pad_d: :class:`.int`
        :param pad_d: padding on one side on the first dimension
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the second dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the third dimension
        :type stride_d: :class:`.int`
        :param stride_d: kernel stride on the first dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the second dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the third dimension
        :type dilate_d: :class:`.int`
        :param dilate_d: dilation (i.e. size of each zero-padded kernel block) on the first dimension
        :type dilate_h: :class:`.int`
        :param dilate_h: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type dilate_w: :class:`.int`
        :param dilate_w: dilation (i.e. size of each zero-padded kernel block) on the third dimension
        :type sparse: :class:`.Convolution3D.Sparse`
        :type data_type: :class:`.Convolution3D.DataType`
        :type format: :class:`.Convolution3D.Format`
        """
        self.mode = Convolution3D.Mode.convert(mode)
        self.pad_d = int(pad_d)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_d = int(stride_d)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.dilate_d = int(dilate_d)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)
        self.sparse = Convolution3D.Sparse.convert(sparse)
        self.data_type = Convolution3D.DataType.convert(data_type)
        self.format = Convolution3D.Format.convert(format)

class Conv3DBias(_ParamDefBase):
    TAG = 2060241070
    class NonlineMode(_EnumBase):
        IDENTITY = "IDENTITY"
        RELU = "RELU"
        SIGMOID = "SIGMOID"
    
    Mode = Convolution3D.Mode
    __slots__ = ["nonlineMode", "mode", "pad_d", "pad_h", "pad_w", "stride_d", "stride_h", "stride_w"]
    _packer = struct.Struct("IIIIIIII0I")
    def __init__(self, nonlineMode='IDENTITY', mode='CROSS_CORRELATION', pad_d=0, pad_h=0, pad_w=0, stride_d=1, stride_h=1, stride_w=0):
        """
        :type nonlineMode: :class:`.Conv3DBias.NonlineMode`
        :type mode: :class:`.Convolution3D.Mode`
        :type pad_d: :class:`.int`
        :type pad_h: :class:`.int`
        :type pad_w: :class:`.int`
        :type stride_d: :class:`.int`
        :type stride_h: :class:`.int`
        :type stride_w: :class:`.int`
        """
        self.nonlineMode = Conv3DBias.NonlineMode.convert(nonlineMode)
        self.mode = Convolution3D.Mode.convert(mode)
        self.pad_d = int(pad_d)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_d = int(stride_d)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)

class SeparableConv3D(_ParamDefBase):
    TAG = 840825259
    Mode = Convolution3D.Mode
    class BorderMode(_EnumBase):
        BORDER_REPLICATE = "BORDER_REPLICATE"
        BORDER_REFLECT = "BORDER_REFLECT"
        BORDER_REFLECT_101 = "BORDER_REFLECT_101"
        BORDER_WRAP = "BORDER_WRAP"
        BORDER_CONSTANT = "BORDER_CONSTANT"
        BORDER_TRANSPARENT = "BORDER_TRANSPARENT"
        BORDER_ISOLATED = "BORDER_ISOLATED"
    
    __slots__ = ["mode", "borderMode", "is_symm_kernel", "pad_d", "pad_h", "pad_w", "stride_d", "stride_h", "stride_w", "ksize_d", "ksize_h", "ksize_w", "anchor_d", "anchor_h", "anchor_w"]
    _packer = struct.Struct("II?IIIIIIIIIIII0I")
    def __init__(self, mode='CROSS_CORRELATION', borderMode='BORDER_REPLICATE', is_symm_kernel=True, pad_d=0, pad_h=0, pad_w=0, stride_d=0, stride_h=1, stride_w=1, ksize_d=0, ksize_h=3, ksize_w=3, anchor_d=0, anchor_h=1, anchor_w=1):
        """
        :type mode: :class:`.Convolution3D.Mode`
        :type borderMode: :class:`.SeparableConv3D.BorderMode`
        :type is_symm_kernel: :class:`.bool`
        :type pad_d: :class:`.int`
        :type pad_h: :class:`.int`
        :type pad_w: :class:`.int`
        :type stride_d: :class:`.int`
        :type stride_h: :class:`.int`
        :type stride_w: :class:`.int`
        :type ksize_d: :class:`.int`
        :type ksize_h: :class:`.int`
        :type ksize_w: :class:`.int`
        :type anchor_d: :class:`.int`
        :type anchor_h: :class:`.int`
        :type anchor_w: :class:`.int`
        """
        self.mode = Convolution3D.Mode.convert(mode)
        self.borderMode = SeparableConv3D.BorderMode.convert(borderMode)
        self.is_symm_kernel = bool(is_symm_kernel)
        self.pad_d = int(pad_d)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_d = int(stride_d)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.ksize_d = int(ksize_d)
        self.ksize_h = int(ksize_h)
        self.ksize_w = int(ksize_w)
        self.anchor_d = int(anchor_d)
        self.anchor_h = int(anchor_h)
        self.anchor_w = int(anchor_w)

class TopK(_ParamDefBase):
    TAG = 1128623317
    class Mode(_EnumBase):
        KTH_ONLY = "KTH_ONLY"
        """
        only the value of the k'th element would be computed
        """
        VALUE_IDX_NOSORT = "VALUE_IDX_NOSORT"
        """
        all the top-k values and corresponding indices would be computed; no
        order is guaranteed
        """
        VALUE_IDX_SORTED = "VALUE_IDX_SORTED"
        """
        all the top-k values and corresponding indices sorted
        """
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='KTH_ONLY'):
        """
        :type mode: :class:`.TopK.Mode`
        """
        self.mode = TopK.Mode.convert(mode)

class RelayoutFormat(_ParamDefBase):
    """
    Change the tensor layout format
    """
    TAG = 448628553
    class Mode(_EnumBase):
        """
        Relayout mode.
        
        **Naming conventions**
        
        1. ``A_B`` means change from layout format ``A`` to ``B``.
        2. ``INTER_WEIGHT_xx`` means relayout the weight for faster processing by
           :attr:`Convolution.Format.NHWCD4` convolutions.
        3. A suffix of ``I`` means ``Image2DPack4TensorFormat`` tensor format is used
           for faster processing on GPUs.
        
        **Layout definitions**
        
        * ``NCHW`` layout: ``{N, C, H, W}``
        * ``NHWC`` layout: ``{N, H, W, C}``
        * ``NHWCD4`` layout: ``{N, H, (C + 3) / 4, W, 4}``
        * ``NHWCD4I`` layout: with ``align_axis = 2``
        * ``NCHW4`` layout: ``{N, C/4, H, W, 4}``
        * ``NCHW88`` layout: ``{N, C/8, H, W, 8}``
        * ``CHWN4`` layout: ``{C/4, H, W, N, 4}``
        
        **Float weight transformation definitions**
        
        +---------------+---------------------------------+--------------------+--------------------------------------+------+
        | Sparsity Type | Input Layout                    | Input Req          | Output Layout                        | Axis |
        +===============+=================================+====================+======================================+======+
        | DENSE         | ``{OC, IC, FH, FW}``            | ``OC % 4 == 0``    | ``{OC/4, FH, FW, IC, 4}``            | 3    |
        +---------------+---------------------------------+--------------------+--------------------------------------+------+
        | GROUP         | ``{GROUP, OCPG, ICPG, FH, FW}`` | ``OCPG % 4 == 0``  | ``{GROUP, OCPG/4, FH, FW, ICPG, 4}`` | 4    |
        |               |                                 | ``ICPG % 4 == 0``  |                                      |      |
        +---------------+---------------------------------+--------------------+--------------------------------------+------+
        | CHAN          | ``{GROUP, 1, 1, FH, FW}``       | ``GROUP % 4 == 0`` | ``{GROUP / 4, 1, FH ,FW, 4}``        | 1    |
        +---------------+---------------------------------+--------------------+--------------------------------------+------+
        
        **Float weight transformation nchw88 definitions**
        
        +---------------+---------------------------------+--------------------+--------------------------------------+
        | Sparsity Type | Input Layout                    | Input Req          | Output Layout                        |
        +===============+=================================+====================+======================================+
        | DENSE         | ``{OC, IC, FH, FW}``            | ``OC % 8 == 0``    |``{OC/8, IC/8 ,FH, FW, 8(IC), 8(OC)}``|
        |               |                                 | ``IC % 8 == 0``    |                                      |
        +---------------+---------------------------------+--------------------+--------------------------------------+
        | GROUP         | ``{GROUP, OCPG, ICPG, FH, FW}`` | ``OCPG % 8 == 0``  | ``{GROUP, OCPG/8, ICPG/8 FH, FW,     |
        |               |                                 | ``ICPG % 8 == 0``  |  8(ICPG), 8(OCPG)} ``                |
        +---------------+---------------------------------+--------------------+--------------------------------------+
        | CHAN          | ``{GROUP, 1, 1, FH, FW}``       | ``GROUP % 8 == 0`` | ``{GROUP / 8, 1, FH ,FW, 8}``        |
        +---------------+---------------------------------+--------------------+--------------------------------------+
        
        **Int8(DOT) weight transformation definitions**
        
        +---------------+---------------------------------+--------------------+------------------------------------------+------+
        | Sparsity Type | Input Layout                    | Input Req          | Output Layout                            | Axis |
        +===============+=================================+====================+==========================================+======+
        | DENSE         | ``{OC, IC, FH, FW}``            | ``OC % 4 == 0``    | ``{OC/4, FH, FW, IC/4, 4, 4}`            | 3    |
        +---------------+---------------------------------+--------------------+------------------------------------------+------+
        | GROUP         | ``{GROUP, OCPG, ICPG, FH, FW}`` | ``OCPG % 4 == 0``  | ``{GROUP, OCPG/4, FH, FW, ICPG/4, 4, 4}``| 4    |
        |               |                                 | ``ICPG % 4 == 0``  |                                          |      |
        +---------------+---------------------------------+--------------------+------------------------------------------+------+
        
        Note: the axis column means the corresponding ``align_axis`` for image format
        when the ``I`` suffix is present.
        
        
        """
        NHWC_NHWCD4 = "NHWC_NHWCD4"
        NHWCD4_NHWC = "NHWCD4_NHWC"
        NHWC_NHWCD4I = "NHWC_NHWCD4I"
        NCHW_NHWCD4 = "NCHW_NHWCD4"
        NCHW_NHWCD4I = "NCHW_NHWCD4I"
        NHWCD4I_NCHW = "NHWCD4I_NCHW"
        NHWCD4_NCHW = "NHWCD4_NCHW"
        INTER_WEIGHT_DENSE = "INTER_WEIGHT_DENSE"
        INTER_WEIGHT_DENSEI = "INTER_WEIGHT_DENSEI"
        INTER_WEIGHT_GROUP = "INTER_WEIGHT_GROUP"
        INTER_WEIGHT_GROUPI = "INTER_WEIGHT_GROUPI"
        INTER_WEIGHT_CHAN = "INTER_WEIGHT_CHAN"
        INTER_WEIGHT_CHANI = "INTER_WEIGHT_CHANI"
        INTER_WEIGHT_DENSEI_DOT = "INTER_WEIGHT_DENSEI_DOT"
        INTER_WEIGHT_GROUPI_DOT = "INTER_WEIGHT_GROUPI_DOT"
        NCHW4_CHWN4 = "NCHW4_CHWN4"
        CHWN4_NCHW4 = "CHWN4_NCHW4"
        NCHW_NCHW88_CONV_DENSE_WEIGHT = "NCHW_NCHW88_CONV_DENSE_WEIGHT"
        NCHW_NCHW88_CONV_CHAN_WEIGHT = "NCHW_NCHW88_CONV_CHAN_WEIGHT"
        NCHW_NCHW88_CONV_GROUP_WEIGHT = "NCHW_NCHW88_CONV_GROUP_WEIGHT"
        NCHW_NCHW88 = "NCHW_NCHW88"
        NCHW88_NCHW = "NCHW88_NCHW"
        NCHW_NCHW4_IC_SMALL = "NCHW_NCHW4_IC_SMALL"
        NCHW_NCHW4_IC_SMALL_CONV_DENSE_WEIGHT = "NCHW_NCHW4_IC_SMALL_CONV_DENSE_WEIGHT"
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='NHWC_NHWCD4'):
        """
        :type mode: :class:`.RelayoutFormat.Mode`
        """
        self.mode = RelayoutFormat.Mode.convert(mode)

class SeparableFilter(_ParamDefBase):
    TAG = 2641095096
    Format = ConvolutionV0.Format
    BorderMode = WarpPerspective.BorderMode
    __slots__ = ["format", "borderMode", "is_symm_kernel", "ksize_h", "ksize_w", "anchor_h", "anchor_w"]
    _packer = struct.Struct("II?IIII0I")
    def __init__(self, format='NCHW', borderMode='REPLICATE', is_symm_kernel=True, ksize_h=3, ksize_w=3, anchor_h=1, anchor_w=1):
        """
        :type format: :class:`.ConvolutionV0.Format`
        :type borderMode: :class:`.WarpPerspective.BorderMode`
        :type is_symm_kernel: :class:`.bool`
        :type ksize_h: :class:`.int`
        :type ksize_w: :class:`.int`
        :type anchor_h: :class:`.int`
        :type anchor_w: :class:`.int`
        """
        self.format = ConvolutionV0.Format.convert(format)
        self.borderMode = WarpPerspective.BorderMode.convert(borderMode)
        self.is_symm_kernel = bool(is_symm_kernel)
        self.ksize_h = int(ksize_h)
        self.ksize_w = int(ksize_w)
        self.anchor_h = int(anchor_h)
        self.anchor_w = int(anchor_w)

class LocalShare(_ParamDefBase):
    """
    Local share convolution
    """
    TAG = 2834312669
    Mode = ConvolutionV0.Mode
    Sparse = ConvolutionV0.Sparse
    Format = ConvolutionV0.Format
    ComputeMode = Convolution.ComputeMode
    __slots__ = ["mode", "pad_h", "pad_w", "stride_h", "stride_w", "dilate_h", "dilate_w", "spatial_groups_h", "spatial_groups_w", "sparse", "format", "computeMode"]
    _packer = struct.Struct("IIIIIIIIIIII0I")
    def __init__(self, mode='CROSS_CORRELATION', pad_h=0, pad_w=0, stride_h=1, stride_w=1, dilate_h=1, dilate_w=1, spatial_groups_h=1, spatial_groups_w=1, sparse='DENSE', format='NCHW', computeMode='DEFAULT'):
        """
        :type mode: :class:`.ConvolutionV0.Mode`
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the first dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the second dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the first dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the second dimension
        :type dilate_h: :class:`.int`
        :param dilate_h: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type dilate_w: :class:`.int`
        :param dilate_w: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type spatial_groups_h: :class:`.int`
        :param spatial_groups_h: spatial groups on the first dimension
        :type spatial_groups_w: :class:`.int`
        :param spatial_groups_w: spatial groups on the second dimension
        :type sparse: :class:`.ConvolutionV0.Sparse`
        :type format: :class:`.ConvolutionV0.Format`
        :type computeMode: :class:`.Convolution.ComputeMode`
        """
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)
        self.spatial_groups_h = int(spatial_groups_h)
        self.spatial_groups_w = int(spatial_groups_w)
        self.sparse = ConvolutionV0.Sparse.convert(sparse)
        self.format = ConvolutionV0.Format.convert(format)
        self.computeMode = Convolution.ComputeMode.convert(computeMode)

class ROIAlign(_ParamDefBase):
    TAG = 2693062405
    class Mode(_EnumBase):
        MAX = "MAX"
        AVERAGE = "AVERAGE"
    
    Format = ConvolutionV0.Format
    __slots__ = ["mode", "format", "spatial_scale", "offset", "pooled_height", "pooled_width", "sample_height", "sample_width"]
    _packer = struct.Struct("IIffIIII0I")
    def __init__(self, mode='MAX', format='NCHW', spatial_scale=1.0, offset=0.0, pooled_height=1, pooled_width=1, sample_height=2, sample_width=2):
        """
        :type mode: :class:`.ROIAlign.Mode`
        :type format: :class:`.ConvolutionV0.Format`
        :type spatial_scale: :class:`.float`
        :type offset: :class:`.float`
        :type pooled_height: :class:`.int`
        :type pooled_width: :class:`.int`
        :type sample_height: :class:`.int`
        :type sample_width: :class:`.int`
        """
        self.mode = ROIAlign.Mode.convert(mode)
        self.format = ConvolutionV0.Format.convert(format)
        self.spatial_scale = float(spatial_scale)
        self.offset = float(offset)
        self.pooled_height = int(pooled_height)
        self.pooled_width = int(pooled_width)
        self.sample_height = int(sample_height)
        self.sample_width = int(sample_width)

class DeformablePSROIPooling(_ParamDefBase):
    TAG = 378949344
    __slots__ = ["no_trans", "spatial_scale", "trans_std", "pooled_h", "pooled_w", "part_size", "sample_per_part"]
    _packer = struct.Struct("?ffIIII0f")
    def __init__(self, no_trans=True, spatial_scale=1, trans_std=1, pooled_h=1, pooled_w=1, part_size=1, sample_per_part=1):
        """
        :type no_trans: :class:`.bool`
        :type spatial_scale: :class:`.float`
        :type trans_std: :class:`.float`
        :type pooled_h: :class:`.int`
        :param pooled_h: height of pooling output
        :type pooled_w: :class:`.int`
        :param pooled_w: width of pooling output
        :type part_size: :class:`.int`
        :param part_size: size of each deformable part
        :type sample_per_part: :class:`.int`
        :param sample_per_part: sample count of each bbox
        """
        self.no_trans = bool(no_trans)
        self.spatial_scale = float(spatial_scale)
        self.trans_std = float(trans_std)
        self.pooled_h = int(pooled_h)
        self.pooled_w = int(pooled_w)
        self.part_size = int(part_size)
        self.sample_per_part = int(sample_per_part)

class BatchConvBias(_ParamDefBase):
    """
    Batch convolution (unshare weights on the batch dimension)
    """
    TAG = 1513184730
    NonlineMode = ConvBiasV0.NonlineMode
    Mode = ConvolutionV0.Mode
    Sparse = ConvolutionV0.Sparse
    Format = ConvolutionV0.Format
    ComputeMode = Convolution.ComputeMode
    __slots__ = ["nonlineMode", "mode", "pad_h", "pad_w", "stride_h", "stride_w", "dilate_h", "dilate_w", "sparse", "format", "compute_mode"]
    _packer = struct.Struct("IIIIIIIIIII0I")
    def __init__(self, nonlineMode='IDENTITY', mode='CROSS_CORRELATION', pad_h=0, pad_w=0, stride_h=1, stride_w=1, dilate_h=1, dilate_w=1, sparse='DENSE', format='NCHW', compute_mode='DEFAULT'):
        """
        :type nonlineMode: :class:`.ConvBiasV0.NonlineMode`
        :type mode: :class:`.ConvolutionV0.Mode`
        :type pad_h: :class:`.int`
        :param pad_h: padding on one side on the first dimension
        :type pad_w: :class:`.int`
        :param pad_w: padding on one side on the second dimension
        :type stride_h: :class:`.int`
        :param stride_h: kernel stride on the first dimension
        :type stride_w: :class:`.int`
        :param stride_w: kernel stride on the second dimension
        :type dilate_h: :class:`.int`
        :param dilate_h: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type dilate_w: :class:`.int`
        :param dilate_w: dilation (i.e. size of each zero-padded kernel block) on the second dimension
        :type sparse: :class:`.ConvolutionV0.Sparse`
        :type format: :class:`.ConvolutionV0.Format`
        :type compute_mode: :class:`.Convolution.ComputeMode`
        """
        self.nonlineMode = ConvBiasV0.NonlineMode.convert(nonlineMode)
        self.mode = ConvolutionV0.Mode.convert(mode)
        self.pad_h = int(pad_h)
        self.pad_w = int(pad_w)
        self.stride_h = int(stride_h)
        self.stride_w = int(stride_w)
        self.dilate_h = int(dilate_h)
        self.dilate_w = int(dilate_w)
        self.sparse = ConvolutionV0.Sparse.convert(sparse)
        self.format = ConvolutionV0.Format.convert(format)
        self.compute_mode = Convolution.ComputeMode.convert(compute_mode)

class DType(_ParamDefBase):
    TAG = 3384694015
    __slots__ = ["dtype"]
    _packer = struct.Struct("I0I")
    def __init__(self, dtype="byte"):
        """
        :type dtype: :class:`._as_dtype_num`
        """
        self.dtype = _as_dtype_num(dtype)

class PersistentOutputStorage(_ParamDefBase):
    TAG = 2701766423
    __slots__ = ["share_key"]
    _packer = struct.Struct("i0i")
    def __init__(self, share_key=-1):
        """
        :type share_key: :class:`.int`
        :param share_key: This is used for controlling memory sharing. Multiple ``PersistentOutputStorage'' oprs with the same ``share_key'' would share underlying tensor storage. Note that the value ``-1'' is treated specially: storage of oprs with this key would be private and would not be shared with any other opr.
        """
        self.share_key = int(share_key)

class OptionalAxis(_ParamDefBase):
    """
    optinal axis: axis == -1 means no axis
    """
    TAG = 652773454
    __slots__ = ["axis"]
    _packer = struct.Struct("i0i")
    def __init__(self, axis=-1):
        """
        :type axis: :class:`.int`
        """
        self.axis = int(axis)

class OptionalAxisV1(_ParamDefBase):
    """
    optinal axis: axis == MAX_NDIM means no axis
    """
    TAG = 2892002433
    MAX_NDIM = 7
    INVALID_AXIS = MAX_NDIM
    __slots__ = ["axis"]
    _packer = struct.Struct("i0i")
    def __init__(self, axis=INVALID_AXIS):
        """
        :type axis: :class:`.int`
        """
        self.axis = int(axis)

class ExecutionPolicy(_ParamDefBase):
    """
    specify how to select an algorithm for an operator
    """
    TAG = 2482374207
    class Strategy(_EnumBase):
        HEURISTIC = "HEURISTIC"
        """
        use heuristic to choose the fastest algorithm
        """
        HEURISTIC_REPRODUCIBLE = "HEURISTIC_REPRODUCIBLE"
        """
        use heuristic to choose the fastest algorithm, and the chosen algorithm
        is reproducible
        """
        PROFILE = "PROFILE"
        """
        run possible algorithms on real device to find the best
        """
        PROFILE_REPRODUCIBLE = "PROFILE_REPRODUCIBLE"
        """
        the fastest of profile result that is also reproducible
        """
        PROFILE_HEURISTIC = "PROFILE_HEURISTIC"
        """
        use profile result and heuristic to choose the fastest algorithm
        """
    
    __slots__ = ["strategy", "workspace_limit"]
    _packer = struct.Struct("IQ0Q")
    def __init__(self, strategy='HEURISTIC', workspace_limit=18446744073709551615):
        """
        :type strategy: :class:`.ExecutionPolicy.Strategy`
        :type workspace_limit: :class:`.int`
        :param workspace_limit: workspace limit in bytes
        """
        self.strategy = ExecutionPolicy.Strategy.convert(strategy)
        self.workspace_limit = int(workspace_limit)

class AssertEqual(_ParamDefBase):
    TAG = 2723797575
    __slots__ = ["maxerr", "verbose"]
    _packer = struct.Struct("f?0f")
    def __init__(self, maxerr=0.0001, verbose=False):
        """
        :type maxerr: :class:`.float`
        :param maxerr: max allowed error error is defined as the minimal of absolute and relative error
        :type verbose: :class:`.bool`
        :param verbose: whether to print maxerr to stdout during opr exec
        """
        self.maxerr = float(maxerr)
        self.verbose = bool(verbose)

class CollectiveComm(_ParamDefBase):
    """
    collective communication between multiple computing nodes on localhost
    """
    TAG = 302993407
    class Mode(_EnumBase):
        """
        mode of collective communication
        """
        REDUCE_SUM = "REDUCE_SUM"
        """
        reduce by sum to output computing node
        """
        BROADCAST = "BROADCAST"
        """
        copy input value to each output computing node
        """
        ALL_GATHER = "ALL_GATHER"
        """
        each output comp node gets the concatenated value of all inputs
        """
        REDUCE_SCATTER_SUM = "REDUCE_SCATTER_SUM"
        """
        reduce inputs by sum and each output gets one part of it
        """
        ALL_REDUCE_SUM = "ALL_REDUCE_SUM"
        """
        every output gets the sum of all inputs
        """
        ALL_REDUCE_MAX = "ALL_REDUCE_MAX"
        """
        every output gets the max of all inputs
        """
        ALL_REDUCE_MIN = "ALL_REDUCE_MIN"
        """
        every output gets the min of all inputs
        """
        ALL_REDUCE_PROD = "ALL_REDUCE_PROD"
        """
        every output gets the prod of all inputs
        """
        GATHER = "GATHER"
        """
        concat inputs to one node
        """
        SCATTER = "SCATTER"
        """
        scatter input to each output computing node
        """
        ALL_TO_ALL = "ALL_TO_ALL"
        """
        scatter inputs and gather them on each computing node
        """
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='REDUCE_SUM'):
        """
        :type mode: :class:`.CollectiveComm.Mode`
        """
        self.mode = CollectiveComm.Mode.convert(mode)

class FakeSerializedDType(_ParamDefBase):
    """
    HACK: The tag of this param def is actually used for another non-generated
    param def SerializedDType, the sole purpose of this param def is to provide
    a spare tag. Do not use.
    """
    TAG = 3091029830
    __slots__ = []
    _packer = struct.Struct("x")
    def __init__(self):
        """
        """

class CondExecPred(_ParamDefBase):
    """
    evaluate a predicate and branch keys to setup ExecutionMask objects with
    associated predicate proxy vars (PPVs)
    """
    TAG = 2266180791
    class Mode(_EnumBase):
        """
        how to compare predicate var with branch keys
        """
        CASE = "CASE"
        """
        The outputs correspond to branch keys, and the one which equals
        predicate would be activated. This behaves like a case-statement in many
        languages.
        """
        CASE_FALLBACK = "CASE_FALLBACK"
        """
        like :attr:`CASE`, but add an extra output that would be activated if no
        branch is matched
        """
        PIECEWISE = "PIECEWISE"
        """
        One more outputs would be produced than the number of branch keys,
        representing the interval in which the predicate var fits in. The
        intervals are defined as :math:`(-\\infty, k_0), [k_0, k_1), \\ldots,
        [k_{n-2}, k_{n-1}), [k_{n-1}, \infty)`. The keys must be given in
        ascending order.
        """
    
    __slots__ = ["mode", "eps"]
    _packer = struct.Struct("If0I")
    def __init__(self, mode='CASE', eps=0.0001):
        """
        :type mode: :class:`.CondExecPred.Mode`
        :type eps: :class:`.float`
        :param eps: threshold for checking equality of float point values
        """
        self.mode = CondExecPred.Mode.convert(mode)
        self.eps = float(eps)

class CondExecPredLogical(_ParamDefBase):
    """
    compute a logical function over a set of PPVs
    """
    TAG = 1659479472
    class Mode(_EnumBase):
        OR = "OR"
        """
        logical or
        """
        AND = "AND"
        """
        logical and
        """
        XOR = "XOR"
        """
        exclusive-or
        """
        NOR = "NOR"
        """
        not or(inputs)
        """
        NAND = "NAND"
        """
        not and(inputs)
        """
        XNOR = "XNOR"
        """
        not xor(inputs)
        """
    
    __slots__ = ["mode"]
    _packer = struct.Struct("I0I")
    def __init__(self, mode='OR'):
        """
        :type mode: :class:`.CondExecPredLogical.Mode`
        """
        self.mode = CondExecPredLogical.Mode.convert(mode)

class CondExecMark(_ParamDefBase):
    """
    add ExecutionMask of the input PPV to this opr and readers of the outputs of
    this opr
    """
    TAG = 3321237194
    class GradMode(_EnumBase):
        """
        mode for computing the gradient
        """
        SUM = "SUM"
        """
        normal gradient mode: sum all the activated components
        """
        SUM_COND_OUT = "SUM_COND_OUT"
        """
        use :attr:`CondExecMerge.SUM_COND_OUT` mode so oprs that depend on the
        gradient opr would not be executed if the forward var is not used.
        """
    
    class StaticInfer(_EnumBase):
        """
        static inference option. **Note:** This is a workaround: since
        currently static inference in MegBrain does not take conditional
        execution into account, this option can be used to bypass static
        inference errors. This is currently only used by automatically
        generated gradient oprs.
        """
        SHAPE_VALUE = "SHAPE_VALUE"
        """
        enable both shape and value inference
        """
        SHAPE_ONLY = "SHAPE_ONLY"
        """
        only enable shape inference (disable value inference)
        """
        NONE = "NONE"
        """
        disable both shape and value inference
        """
    
    __slots__ = ["grad_mode", "static_infer"]
    _packer = struct.Struct("II0I")
    def __init__(self, grad_mode='SUM', static_infer='SHAPE_VALUE'):
        """
        :type grad_mode: :class:`.CondExecMark.GradMode`
        :type static_infer: :class:`.CondExecMark.StaticInfer`
        """
        self.grad_mode = CondExecMark.GradMode.convert(grad_mode)
        self.static_infer = CondExecMark.StaticInfer.convert(static_infer)

class CondExecMerge(_ParamDefBase):
    """
    merge multiple conditional execution branches
    """
    TAG = 1835965897
    class Mode(_EnumBase):
        EXACT_ONE = "EXACT_ONE"
        """
        copy the var whose mask is activated to the output, requiring that
        exactly one branch is active
        """
        EXACT_ONE_SAME_SHAPE = "EXACT_ONE_SAME_SHAPE"
        """
        like :attr:`EXACT_ONE` with the requirement that all branches have the
        same shape, so shape inference can be easier
        """
        SUM = "SUM"
        """
        sum all the active branches into output var; require all branches to
        have the same shape. Extra shape vars are needed in this mod, so the
        outputs can be initialized to zero when no input is active (and their
        shapes are probably unknown).
        """
        SUM_COND_OUT = "SUM_COND_OUT"
        """
        like :attr:`SUM` but also add an ExecutionMask to the readers of output
        vars, so they would be skipped if  no branch is taken
        """
    
    __slots__ = ["nr_output", "mode"]
    _packer = struct.Struct("II0I")
    def __init__(self, nr_output=1, mode='EXACT_ONE'):
        """
        :type nr_output: :class:`.int`
        :param nr_output: number of output vars (i.e. vars per branch)
        :type mode: :class:`.CondExecMerge.Mode`
        """
        self.nr_output = int(nr_output)
        self.mode = CondExecMerge.Mode.convert(mode)


class SerializedDType(_ParamDefBase):
    TAG = FakeSerializedDType.TAG
    __slots__ = ['dtype']
    class IdentityPacker:
        def pack(self, *args):
            assert all([isinstance(x, bytes) for x in args])
            return b''.join(args)
    _packer = IdentityPacker()
    def __init__(self, dtype):
        """
        :type dtype: :class:`np.dtype` compatible
        """
        self.dtype = _as_serialized_dtype(dtype)

_enum_member2num = {
  id(ConvolutionV0.Mode.CROSS_CORRELATION):0,
  id(ConvolutionV0.Mode.CONVOLUTION):1,
  id(ConvolutionV0.DataType.FLOAT):0,
  id(ConvolutionV0.DataType.INT8x8x16):1,
  id(ConvolutionV0.DataType.INT8x8x32):2,
  id(ConvolutionV0.DataType.FLOAT_IO16xC32):3,
  id(ConvolutionV0.DataType.QUINT8x8x32):4,
  id(ConvolutionV0.DataType.INT8x8xX):5,
  id(ConvolutionV0.DataType.QUINT4x4x32):6,
  id(ConvolutionV0.Sparse.DENSE):0,
  id(ConvolutionV0.Sparse.GROUP):1,
  id(ConvolutionV0.Format.NCHW):0,
  id(ConvolutionV0.Format.NHWC):1,
  id(ConvolutionV0.Format.NHWCD4):2,
  id(ConvolutionV0.Format.NCHW4):3,
  id(ConvolutionV0.Format.NCHW8):4,
  id(ConvolutionV0.Format.NCHW32):5,
  id(ConvolutionV0.Format.NCHW88):6,
  id(ConvolutionV0.Format.NCHW44):7,
  id(ConvolutionV0.Format.NCHW44_DOT):8,
  id(ConvolutionV0.Format.NCHW_WINOGRAD):9,
  id(ConvolutionV0.Format.NCHW88_WINOGRAD):10,
  id(ConvolutionV0.Format.NCHW44_WINOGRAD):11,
  id(ConvolutionV0.Format.CHWN4):12,
  id(Convolution.ComputeMode.DEFAULT):0,
  id(Convolution.ComputeMode.FLOAT32):1,
  id(ConvPooling.Method.WITH_TEXTURE_OBJ):0,
  id(ConvPooling.Method.WITH_SHARED_MEM):1,
  id(ConvPooling.PoolMode.AVERAGE):0,
  id(ConvPooling.PoolMode.MAX):1,
  id(ConvPooling.NonlineMode.IDENTITY):0,
  id(ConvPooling.NonlineMode.RELU):1,
  id(ConvPooling.NonlineMode.SIGMOID):2,
  id(ConvBiasV0.NonlineMode.IDENTITY):0,
  id(ConvBiasV0.NonlineMode.RELU):1,
  id(ConvBiasV0.NonlineMode.SIGMOID):2,
  id(ConvBiasV0.NonlineMode.H_SWISH):3,
  id(SeparableConv.BorderMode.BORDER_REPLICATE):0,
  id(SeparableConv.BorderMode.BORDER_REFLECT):1,
  id(SeparableConv.BorderMode.BORDER_REFLECT_101):2,
  id(SeparableConv.BorderMode.BORDER_WRAP):3,
  id(SeparableConv.BorderMode.BORDER_CONSTANT):4,
  id(SeparableConv.BorderMode.BORDER_TRANSPARENT):5,
  id(SeparableConv.BorderMode.BORDER_ISOLATED):6,
  id(Pooling.Mode.MAX):0,
  id(Pooling.Mode.AVERAGE):1,
  id(Pooling.Mode.AVERAGE_COUNT_EXCLUDE_PADDING):2,
  id(BN.ParamDim.DIM_11HW):0,
  id(BN.ParamDim.DIM_1CHW):1,
  id(BN.ParamDim.DIM_1C11):2,
  id(BN.FwdMode.TRAINING):0,
  id(BN.FwdMode.INFERENCE):1,
  id(ROIPooling.Mode.MAX):0,
  id(ROIPooling.Mode.AVERAGE):1,
  id(WarpPerspective.InterpolationMode.NEAREST):0,
  id(WarpPerspective.InterpolationMode.LINEAR):1,
  id(WarpPerspective.InterpolationMode.AREA):2,
  id(WarpPerspective.InterpolationMode.CUBIC):3,
  id(WarpPerspective.InterpolationMode.LANCZOS4):4,
  id(WarpPerspective.BorderMode.REPLICATE):0,
  id(WarpPerspective.BorderMode.REFLECT):1,
  id(WarpPerspective.BorderMode.REFLECT_101):2,
  id(WarpPerspective.BorderMode.WRAP):3,
  id(WarpPerspective.BorderMode.CONSTANT):4,
  id(WarpPerspective.BorderMode.TRANSPARENT):5,
  id(WarpPerspective.BorderMode.ISOLATED):6,
  id(SpatialTfGridGenerator.Mode.AFFINE):0,
  id(SpatialTfSampler.Mode.BILINEAR):0,
  id(Elemwise.Mode.RELU):0,
  id(Elemwise.Mode.ABS):1,
  id(Elemwise.Mode.ACOS):2,
  id(Elemwise.Mode.ASIN):3,
  id(Elemwise.Mode.CEIL):4,
  id(Elemwise.Mode.COS):5,
  id(Elemwise.Mode.EXP):6,
  id(Elemwise.Mode.EXPM1):7,
  id(Elemwise.Mode.FLOOR):8,
  id(Elemwise.Mode.LOG):9,
  id(Elemwise.Mode.LOG1P):10,
  id(Elemwise.Mode.NEGATE):11,
  id(Elemwise.Mode.SIGMOID):12,
  id(Elemwise.Mode.SIN):13,
  id(Elemwise.Mode.TANH):14,
  id(Elemwise.Mode.ABS_GRAD):15,
  id(Elemwise.Mode.ADD):16,
  id(Elemwise.Mode.FLOOR_DIV):17,
  id(Elemwise.Mode.MAX):18,
  id(Elemwise.Mode.MIN):19,
  id(Elemwise.Mode.MOD):20,
  id(Elemwise.Mode.MUL):21,
  id(Elemwise.Mode.POW):22,
  id(Elemwise.Mode.SIGMOID_GRAD):23,
  id(Elemwise.Mode.SUB):24,
  id(Elemwise.Mode.SWITCH_GT0):25,
  id(Elemwise.Mode.TANH_GRAD):26,
  id(Elemwise.Mode.TRUE_DIV):27,
  id(Elemwise.Mode.LOG_SUM_EXP):28,
  id(Elemwise.Mode.LT):29,
  id(Elemwise.Mode.LEQ):30,
  id(Elemwise.Mode.EQ):31,
  id(Elemwise.Mode.SHL):32,
  id(Elemwise.Mode.SHR):33,
  id(Elemwise.Mode.COND_LEQ_MOV):34,
  id(Elemwise.Mode.FUSE_MUL_ADD3):35,
  id(Elemwise.Mode.FUSE_MUL_ADD4):36,
  id(Elemwise.Mode.FUSE_ADD_RELU):37,
  id(Elemwise.Mode.FUSE_ADD_SIGMOID):38,
  id(Elemwise.Mode.FUSE_ADD_TANH):39,
  id(Elemwise.Mode.FAST_TANH):40,
  id(Elemwise.Mode.FAST_TANH_GRAD):41,
  id(Elemwise.Mode.ROUND):42,
  id(Elemwise.Mode.RMULH):43,
  id(Elemwise.Mode.ATAN2):44,
  id(Elemwise.Mode.ERF):45,
  id(Elemwise.Mode.ERFINV):46,
  id(Elemwise.Mode.ERFC):47,
  id(Elemwise.Mode.ERFCINV):48,
  id(Elemwise.Mode.H_SWISH):49,
  id(Elemwise.Mode.H_SWISH_GRAD):50,
  id(Elemwise.Mode.FUSE_ADD_H_SWISH):51,
  id(Elemwise.Mode.NOT):52,
  id(Elemwise.Mode.AND):53,
  id(Elemwise.Mode.OR):54,
  id(Elemwise.Mode.XOR):55,
  id(ElemwiseMultiType.Mode.FUSE_MUL_ADD3_INT16x32x32x32):0,
  id(ElemwiseMultiType.Mode.FUSE_MUL_ADD3_IXxF32xF32xI8):1,
  id(ElemwiseMultiType.Mode.ROUND_SHR_SATURATE_IXxI8xI8):2,
  id(ElemwiseMultiType.Mode.FUSE_ADD_RMULH_ROUND_SHR_SATURATE_INT16x16x16x8):3,
  id(ElemwiseMultiType.Mode.FUSE_ADD_RMULH_ROUND_SHR_SATURATE_INT32x32x32x8):4,
  id(ElemwiseMultiType.Mode.ROUND_SHR_SATURATE_IXxI8xI16):5,
  id(ElemwiseMultiType.Mode.QADD):6,
  id(ElemwiseMultiType.Mode.QFUSE_ADD_RELU):7,
  id(ElemwiseMultiType.Mode.QMUL):8,
  id(ElemwiseMultiType.Mode.QMIN):9,
  id(ElemwiseMultiType.Mode.QMAX):10,
  id(ElemwiseMultiType.Mode.QSUB):11,
  id(ElemwiseMultiType.Mode.QTRUE_DIV):12,
  id(ElemwiseMultiType.Mode.QFUSE_ADD_SIGMOID):13,
  id(ElemwiseMultiType.Mode.QFUSE_ADD_TANH):14,
  id(ElemwiseMultiType.Mode.QRELU):15,
  id(ElemwiseMultiType.Mode.QABS):16,
  id(ElemwiseMultiType.Mode.QSIGMOID):17,
  id(ElemwiseMultiType.Mode.QEXP):18,
  id(ElemwiseMultiType.Mode.QTANH):19,
  id(ElemwiseMultiType.Mode.QFUSE_MUL_ADD3):20,
  id(ElemwiseMultiType.Mode.QFAST_TANH):21,
  id(ElemwiseMultiType.Mode.QNEGATE):22,
  id(ElemwiseMultiType.Mode.QACOS):23,
  id(ElemwiseMultiType.Mode.QASIN):24,
  id(ElemwiseMultiType.Mode.QCEIL):25,
  id(ElemwiseMultiType.Mode.QCOS):26,
  id(ElemwiseMultiType.Mode.QEXPM1):27,
  id(ElemwiseMultiType.Mode.QFLOOR):28,
  id(ElemwiseMultiType.Mode.QLOG):29,
  id(ElemwiseMultiType.Mode.QLOG1P):30,
  id(ElemwiseMultiType.Mode.QSIN):31,
  id(ElemwiseMultiType.Mode.QROUND):32,
  id(ElemwiseMultiType.Mode.QERF):33,
  id(ElemwiseMultiType.Mode.QERFINV):34,
  id(ElemwiseMultiType.Mode.QERFC):35,
  id(ElemwiseMultiType.Mode.QERFCINV):36,
  id(ElemwiseMultiType.Mode.QABS_GRAD):37,
  id(ElemwiseMultiType.Mode.QFLOOR_DIV):38,
  id(ElemwiseMultiType.Mode.QMOD):39,
  id(ElemwiseMultiType.Mode.QSIGMOID_GRAD):40,
  id(ElemwiseMultiType.Mode.QSWITCH_GT0):41,
  id(ElemwiseMultiType.Mode.QTANH_GRAD):42,
  id(ElemwiseMultiType.Mode.QLT):43,
  id(ElemwiseMultiType.Mode.QLEQ):44,
  id(ElemwiseMultiType.Mode.QEQ):45,
  id(ElemwiseMultiType.Mode.QPOW):46,
  id(ElemwiseMultiType.Mode.QLOG_SUM_EXP):47,
  id(ElemwiseMultiType.Mode.QFAST_TANH_GRAD):48,
  id(ElemwiseMultiType.Mode.QATAN2):49,
  id(ElemwiseMultiType.Mode.QCOND_LEQ_MOV):50,
  id(ElemwiseMultiType.Mode.QH_SWISH):51,
  id(ElemwiseMultiType.Mode.QFUSE_ADD_H_SWISH):52,
  id(ElemwiseMultiType.Mode.QH_SWISH_GRAD):53,
  id(MatrixMulV0.DataType.FLOAT):0,
  id(MatrixMulV0.DataType.INT8x8x16):1,
  id(MatrixMulV0.DataType.INT8x8x32):2,
  id(MatrixMulV0.DataType.FLOAT_IO16xC32):3,
  id(MatrixMulV0.DataType.QUINT8x8x32):4,
  id(MatrixMulV0.DataType.QUINT4x4x32):5,
  id(MatrixMulV1.ComputeMode.DEFAULT):0,
  id(MatrixMulV1.ComputeMode.FLOAT32):1,
  id(MatrixMul.Format.DEFAULT):0,
  id(MatrixMul.Format.MK4):1,
  id(MatrixMul.Format.MK8):2,
  id(MatrixMul.Format.MK4_DOT):3,
  id(ReduceV0.Mode.SUM):0,
  id(ReduceV0.Mode.SUM_SQR):1,
  id(ReduceV0.Mode.PRODUCT):2,
  id(ReduceV0.Mode.MIN):3,
  id(ReduceV0.Mode.MAX):4,
  id(ReduceV1.Mode.SUM):0,
  id(ReduceV1.Mode.SUM_SQR):1,
  id(ReduceV1.Mode.PRODUCT):2,
  id(ReduceV1.Mode.MIN):3,
  id(ReduceV1.Mode.MAX):4,
  id(ReduceV1.Mode.MEAN):5,
  id(ReduceV1.DataType.DEFAULT):0,
  id(ReduceV1.DataType.FLOAT_IO16xC32):1,
  id(ReduceV1.DataType.FLOAT_O32xC32):2,
  id(ReduceV1.DataType.FLOAT_O16xC32):3,
  id(ReduceV1.DataType.QUINT_I8xO32):4,
  id(ReduceV1.DataType.QINT_I8xO32):5,
  id(Reduce.Mode.SUM):0,
  id(Reduce.Mode.SUM_SQR):1,
  id(Reduce.Mode.PRODUCT):2,
  id(Reduce.Mode.MIN):3,
  id(Reduce.Mode.MAX):4,
  id(Reduce.Mode.MEAN):5,
  id(Reduce.DataType.DEFAULT):0,
  id(Reduce.DataType.FLOAT_IO16xC32):1,
  id(Reduce.DataType.FLOAT_O32xC32):2,
  id(Reduce.DataType.FLOAT_O16xC32):3,
  id(Reduce.DataType.QUINT_I8xO32):4,
  id(Reduce.DataType.QINT_I8xO32):5,
  id(CondTake.Mode.EQ):0,
  id(CondTake.Mode.NEQ):1,
  id(CondTake.Mode.LT):2,
  id(CondTake.Mode.LEQ):3,
  id(CondTake.Mode.GT):4,
  id(CondTake.Mode.GEQ):5,
  id(Argsort.Order.ASCENDING):0,
  id(Argsort.Order.DESCENDING):1,
  id(CvtColor.Mode.RGB2GRAY):0,
  id(CvtColor.Mode.RGB2YUV):1,
  id(CvtColor.Mode.YUV2RGB):2,
  id(CvtColor.Mode.GRAY2RGB):3,
  id(CvtColor.Mode.RGBA2RGB):4,
  id(CvtColor.Mode.RGBA2BGR):5,
  id(CvtColor.Mode.RGBA2GRAY):6,
  id(CvtColor.Mode.RGB2BGR):7,
  id(CvtColor.Mode.BGR2GRAY):8,
  id(CvtColor.Mode.BGR2RGB):9,
  id(CvtColor.Mode.YUV2GRAY_NV21):10,
  id(CvtColor.Mode.YUV2RGB_NV21):11,
  id(CvtColor.Mode.YUV2BGR_NV21):12,
  id(CvtColor.Mode.YUV2GRAY_NV12):13,
  id(CvtColor.Mode.YUV2RGB_NV12):14,
  id(CvtColor.Mode.YUV2BGR_NV12):15,
  id(CvtColor.Mode.YUV2GRAY_YV12):16,
  id(CvtColor.Mode.YUV2RGB_YV12):17,
  id(CvtColor.Mode.YUV2BGR_YV12):18,
  id(CvtColor.Mode.YUV2GRAY_YU12):19,
  id(CvtColor.Mode.YUV2RGB_YU12):20,
  id(CvtColor.Mode.YUV2BGR_YU12):21,
  id(CvtColor.Mode.YCrCb2RGB):22,
  id(CvtColor.Mode.YCrCb2BGR):23,
  id(CvtColor.Mode.BT601_YUV2RGB_NV21):24,
  id(CvtColor.Mode.BT601_YUV2BGR_NV21):25,
  id(CvtColor.Mode.BT601_YUV2RGB_NV12):26,
  id(CvtColor.Mode.BT601_YUV2BGR_NV12):27,
  id(CvtColor.Mode.BT601_YUV2RGB_YV12):28,
  id(CvtColor.Mode.BT601_YUV2BGR_YV12):29,
  id(CvtColor.Mode.BT601_YUV2RGB_YU12):30,
  id(CvtColor.Mode.BT601_YUV2BGR_YU12):31,
  id(Convolution3D.Mode.CROSS_CORRELATION):0,
  id(Convolution3D.Mode.CONVOLUTION):1,
  id(Convolution3D.Sparse.DENSE):0,
  id(Convolution3D.Sparse.GROUP):1,
  id(Convolution3D.DataType.FLOAT):0,
  id(Convolution3D.DataType.FLOAT_IO16xC32):1,
  id(Convolution3D.Format.NCDHW):0,
  id(Convolution3D.Format.NDHWC):1,
  id(Conv3DBias.NonlineMode.IDENTITY):0,
  id(Conv3DBias.NonlineMode.RELU):1,
  id(Conv3DBias.NonlineMode.SIGMOID):2,
  id(SeparableConv3D.BorderMode.BORDER_REPLICATE):0,
  id(SeparableConv3D.BorderMode.BORDER_REFLECT):1,
  id(SeparableConv3D.BorderMode.BORDER_REFLECT_101):2,
  id(SeparableConv3D.BorderMode.BORDER_WRAP):3,
  id(SeparableConv3D.BorderMode.BORDER_CONSTANT):4,
  id(SeparableConv3D.BorderMode.BORDER_TRANSPARENT):5,
  id(SeparableConv3D.BorderMode.BORDER_ISOLATED):6,
  id(TopK.Mode.KTH_ONLY):0,
  id(TopK.Mode.VALUE_IDX_NOSORT):1,
  id(TopK.Mode.VALUE_IDX_SORTED):2,
  id(RelayoutFormat.Mode.NHWC_NHWCD4):0,
  id(RelayoutFormat.Mode.NHWCD4_NHWC):1,
  id(RelayoutFormat.Mode.NHWC_NHWCD4I):2,
  id(RelayoutFormat.Mode.NCHW_NHWCD4):3,
  id(RelayoutFormat.Mode.NCHW_NHWCD4I):4,
  id(RelayoutFormat.Mode.NHWCD4I_NCHW):5,
  id(RelayoutFormat.Mode.NHWCD4_NCHW):6,
  id(RelayoutFormat.Mode.INTER_WEIGHT_DENSE):7,
  id(RelayoutFormat.Mode.INTER_WEIGHT_DENSEI):8,
  id(RelayoutFormat.Mode.INTER_WEIGHT_GROUP):9,
  id(RelayoutFormat.Mode.INTER_WEIGHT_GROUPI):10,
  id(RelayoutFormat.Mode.INTER_WEIGHT_CHAN):11,
  id(RelayoutFormat.Mode.INTER_WEIGHT_CHANI):12,
  id(RelayoutFormat.Mode.INTER_WEIGHT_DENSEI_DOT):13,
  id(RelayoutFormat.Mode.INTER_WEIGHT_GROUPI_DOT):14,
  id(RelayoutFormat.Mode.NCHW4_CHWN4):15,
  id(RelayoutFormat.Mode.CHWN4_NCHW4):16,
  id(RelayoutFormat.Mode.NCHW_NCHW88_CONV_DENSE_WEIGHT):17,
  id(RelayoutFormat.Mode.NCHW_NCHW88_CONV_CHAN_WEIGHT):18,
  id(RelayoutFormat.Mode.NCHW_NCHW88_CONV_GROUP_WEIGHT):19,
  id(RelayoutFormat.Mode.NCHW_NCHW88):20,
  id(RelayoutFormat.Mode.NCHW88_NCHW):21,
  id(RelayoutFormat.Mode.NCHW_NCHW4_IC_SMALL):22,
  id(RelayoutFormat.Mode.NCHW_NCHW4_IC_SMALL_CONV_DENSE_WEIGHT):23,
  id(ROIAlign.Mode.MAX):0,
  id(ROIAlign.Mode.AVERAGE):1,
  id(ExecutionPolicy.Strategy.HEURISTIC):0,
  id(ExecutionPolicy.Strategy.HEURISTIC_REPRODUCIBLE):1,
  id(ExecutionPolicy.Strategy.PROFILE):2,
  id(ExecutionPolicy.Strategy.PROFILE_REPRODUCIBLE):3,
  id(ExecutionPolicy.Strategy.PROFILE_HEURISTIC):4,
  id(CollectiveComm.Mode.REDUCE_SUM):0,
  id(CollectiveComm.Mode.BROADCAST):1,
  id(CollectiveComm.Mode.ALL_GATHER):2,
  id(CollectiveComm.Mode.REDUCE_SCATTER_SUM):3,
  id(CollectiveComm.Mode.ALL_REDUCE_SUM):4,
  id(CollectiveComm.Mode.ALL_REDUCE_MAX):5,
  id(CollectiveComm.Mode.ALL_REDUCE_MIN):6,
  id(CollectiveComm.Mode.ALL_REDUCE_PROD):7,
  id(CollectiveComm.Mode.GATHER):8,
  id(CollectiveComm.Mode.SCATTER):9,
  id(CollectiveComm.Mode.ALL_TO_ALL):10,
  id(CondExecPred.Mode.CASE):0,
  id(CondExecPred.Mode.CASE_FALLBACK):1,
  id(CondExecPred.Mode.PIECEWISE):2,
  id(CondExecPredLogical.Mode.OR):0,
  id(CondExecPredLogical.Mode.AND):1,
  id(CondExecPredLogical.Mode.XOR):2,
  id(CondExecPredLogical.Mode.NOR):3,
  id(CondExecPredLogical.Mode.NAND):4,
  id(CondExecPredLogical.Mode.XNOR):5,
  id(CondExecMark.GradMode.SUM):0,
  id(CondExecMark.GradMode.SUM_COND_OUT):1,
  id(CondExecMark.StaticInfer.SHAPE_VALUE):0,
  id(CondExecMark.StaticInfer.SHAPE_ONLY):1,
  id(CondExecMark.StaticInfer.NONE):2,
  id(CondExecMerge.Mode.EXACT_ONE):0,
  id(CondExecMerge.Mode.EXACT_ONE_SAME_SHAPE):1,
  id(CondExecMerge.Mode.SUM):2,
  id(CondExecMerge.Mode.SUM_COND_OUT):3}
